/* FPGE.C the main section of fpge. Here and in .h we define data structure */
/* ,global variables and the main dialog dmain                              */

#include "allegro.h"
//here remove some stuff from allegro to reduce size....
BEGIN_GFX_DRIVER_LIST
   GFX_DRIVER_VBEAF
   GFX_DRIVER_VGA
   //GFX_DRIVER_MODEX
   GFX_DRIVER_VESA3
   GFX_DRIVER_VESA2L
   GFX_DRIVER_VESA2B
   GFX_DRIVER_XTENDED
   GFX_DRIVER_VESA1
END_GFX_DRIVER_LIST


BEGIN_COLOR_DEPTH_LIST
   COLOR_DEPTH_8
   //COLOR_DEPTH_15
   //COLOR_DEPTH_16
   // COLOR_DEPTH_24
   //COLOR_DEPTH_32
END_COLOR_DEPTH_LIST




#include <stdio.h>
#include "fpge.h"

  //these are the indexes of components for the main dialog dm
  #define dmUnitBtnIdx 1
  #define dmTerBtnIdx 2
  #define dmVictBtnIdx 3
  #define dmOwnBtnIdx 4
  #define dmLoadBtnIdx 5
  #define dmSaveBtnIdx 6
  #define dmExitBtnIdx 7
  #define dmMapBmpIdx 8
  #define dmLeftArrowIdx 9
  #define dmRightArrowIdx 10
  #define dmUpArrowIdx 11
  #define dmDownArrowIdx 12
  #define dmHSlideIdx 13
  #define dmVSlideIdx 14
  #define dmGndRBIdx 15
  #define dmAirRBIdx 16
  #define dmMapInfoTxtIdx 17
  #define dmMapStatusIdx 18
  #define dmPlaceBtnIdx 19
  #define dmExpBtnIdx 20
  #define dmStrBtnIdx 21
  #define dmEntBtnIdx 22
  #define dmCoreRBIdx 23
  #define dmAuxRBIdx  24
  #define dmAlliedRBIdx 25
  #define dmScenBtnIdx 26
  #define dmTileBtnIdx 27
  #define dmDeployBtnIdx 28
  #define dmNeutralBtnIdx 29

char MapInfoTxt[256];
char MapStatusTxt[256]="Fred's Panzer General Editor\nVersion 0.1";
enum UTYPES ubelongs=core;
short temp[MAX_TILES]; //use this for storing map bmp when viewing tiles

/* -----  this defines the objects that are part of dmain */
DIALOG dm[]=
{
//0 DIALOG dmClear=
{  d_clear_proc,         //default button
   0,0,0,0,              // x,y,w,h
   0,SCREEN_COLOR,                // foreground and background
   0,                    // hotkey
   0,                    // flags
   0,0,                  // d1 and d2
   0,0,0                 // dp dp1 dp2
},

//1 DIALOG dmUnitBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-5*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   1,0,                  // d1 and d2
   "UNIT",0,0            // dp dp1 dp2
},
// 2 DIALOG dmTerrBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-11*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   2,0,                  // d1 and d2
   "TERR",0,0            // dp dp1 dp2
},
// 3 DIALOG dmVictBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-13*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   3,0,                  // d1 and d2
   "VICT",0,0            // dp dp1 dp2
},
// 4 DIALOG dmOwnerBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-12*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   4,0,                  // d1 and d2
   "OWNER",0,0            // dp dp1 dp2
},
// 5 DIALOG dmLoadBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-3*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   5,0,                  // d1 and d2
   "LOAD",0,0            // dp dp1 dp2
},
// 6 DIALOG dmSaveBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-2*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,                  // foreground and background
   0,                    // hotkey
   0,                    // flags
   6,0,                  // d1 and d2
   "SAVE",0,0            // dp dp1 dp2
},
// 7 DIALOG dmExitBtn=
{  d_btn_proc,            //default button
   MAIN_BUTTON_X,EXIT_Y-1*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,                  // foreground and background
   0,                    // hotkey
   D_EXIT,               // flags
   7,0,                  // d1 and d2
   "EXIT",0,0            // dp dp1 dp2
},
// 8 DIALOG dmMapBmp=
{
  d_mapbmp_proc,
  0,LINE_2_Y,MAP_W,MAP_H,
  0,MAP_COLOR,
  0,
  0,
  0,0,
  0,0,0
},
// 9 DIALOG dmLeftArrowBmp=
{
  d_arrow_proc,
  HSLIDE_X-2-HSLIDE_H,HSLIDE_Y,HSLIDE_H,HSLIDE_H,
  0,0,
  0,
  0,
  (int) 'L',0,
  0,0,0
},
// 10 DIALOG dmRightArrowBmp=
{
  d_arrow_proc,
  HSLIDE_X+3+HSLIDE_W,LINE_1_Y,HSLIDE_H,HSLIDE_H,
  0,0,
  0,
  0,
  (int) 'R',0,
  0,0,0
},
// 11 DIALOG dmUpArrowBmp=
{
  d_arrow_proc,
  VSLIDE_X,VSLIDE_Y-VSLIDE_W-2,VSLIDE_W,VSLIDE_W,
  0,0,
  0,
  0,
  (int) 'U',0,
  0,0,0
},
// 12 DIALOG dmDownArrowBmp=
{
  d_arrow_proc,
  VSLIDE_X,VSLIDE_Y+2+VSLIDE_H,VSLIDE_W,VSLIDE_W,
  0,0,
  0,
  0,
  (int) 'D',0,
  0,0,0
},
// 13 DIALOG dmHSlide=
{
  d_hslide_proc,
  HSLIDE_X,LINE_1_Y,HSLIDE_W,HSLIDE_H,
  SLIDE_FG_COLOR,SLIDE_BG_COLOR,
  0,
  0,
  100,0,
  0,0,0
},
// 14 DIALOG dmVSlide=
{
  d_vslide_proc,
  VSLIDE_X,VSLIDE_Y,VSLIDE_W,VSLIDE_H,
  SLIDE_FG_COLOR,SLIDE_BG_COLOR,
  0,
  0,
  100,0,
  0,0,0
},
// 15 DIALOG dmGndRB=
{
  d_GndAir_proc,
  HSLIDE_X,LINE_1_Y-13,20,10,
  FG_COLOR,SCREEN_COLOR,
  0,
  D_SELECTED,
  100,0,
  "Gnd",0,0
},
// 16 DIALOG dmAirRB=
{
  d_GndAir_proc,
  HSLIDE_X+50,LINE_1_Y-13,20,10,
  FG_COLOR,SCREEN_COLOR,
  0,
  0,
  100,0,
  "Air",0,0
},
// 17 DIALOG dmMapInfoTxt=
{
  d_mapinfo_proc,
  1,2,170,50,
  FG_COLOR,SCREEN_COLOR,
  0,
  0,
  0,0,
  MapInfoTxt,0,0
},
// 18 DIALOG dmMapStatusTxt=
{
  d_mapstatus_proc,
  430,2,200,48,
  FG_COLOR,SCREEN_COLOR,
  0,
  0,
  0,0,
  MapStatusTxt,0,0
},
// 19 DIALOG dmPlaceBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-6*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   8,0,                  // d1 and d2
   "PLACE",0,0            // dp dp1 dp2
},
// 20 DIALOG dmExpBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-7*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   9,0,                  // d1 and d2
   "EXP",0,0            // dp dp1 dp2
},
// 21 DIALOG dmStrBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-8*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   10,0,                  // d1 and d2
   "STR",0,0            // dp dp1 dp2
},
// 22 DIALOG dmEntBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-9*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   11,0,                  // d1 and d2
   "ENT",0,0            // dp dp1 dp2
},

// 23 DIALOG dmCoreRB=
{
  d_coreRB_proc,
  HSLIDE_X,2,20,10,
  FG_COLOR,SCREEN_COLOR,
  0,
  D_SELECTED,
  99,0,
  "Core",0,0
},

// 24 DIALOG dmAuxRB=
{
  d_coreRB_proc,
  HSLIDE_X+50,2,20,10,
  FG_COLOR,SCREEN_COLOR,
  0,
  0,
  99,0,
  "Aux",0,0
},

// 25 DIALOG dmAlliedRB=
{
  d_coreRB_proc,
  HSLIDE_X+100,2,20,10,
  FG_COLOR,SCREEN_COLOR,
  0,
  0,
  99,0,
  "Allied",0,0
},

// 26 DIALOG dmScenBtn=
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-4*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   26,0,                  // d1 and d2
   "SCEN",0,0            // dp dp1 dp2
},
// 27 dmTileBtn
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-10*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   27,0,                  // d1 and d2
   "TILES",0,0            // dp dp1 dp2
},
//28 deploy button
{  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-14*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   28,0,                  // d1 and d2
   "DPLY",0,0            // dp dp1 dp2
},
//29 Neutral button
{
  d_btn_proc,         //default button
   MAIN_BUTTON_X,EXIT_Y-15*BUTTON_SIZE,BUTTON_W,BUTTON_H,  // x,y,w,h
   FG_COLOR,BG_COLOR,    // foreground and background
   0,                    // hotkey
   0,                    // flags
   28,0,                  // d1 and d2
   "NEUT",0,0            // dp dp1 dp2
},

//DIALOG dmNull=
{NULL}
}; //end of dm defineition
/* -------------------------------------------- */

/* ----- the initialization of dm ---------------------------------- */
#define dm_OBJECTS 29  //number of objects in dm Dialog
#define FUNCTION_BUTTONS 11//buttons number 1-this are radio type

void initialize_dm()
{
  gui_fg_color=FG_COLOR; gui_bg_color=BG_COLOR;

}

/* ------------- Here ends the main dialog ----------------------------- */

/* -------------- Globals --------------------------------------- */
struct shp_header header;
struct MAP  map[MAX_MAP_X][MAX_MAP_Y]; //main map storage
unsigned char equip[MAX_UNITS][EQUIP_REC_SIZE];

BYTE scn_buffer[MAX_SCN_SIZE];
int scn_size; //bytes we actually read
BYTE s4_buffer[16]; //hold prestige and transport info
                    //s4 data starts at scn_buffer[0x75]*4+0x77
enum EDIT_FUNCTION edit_op;

struct UNIT all_units[MAX_CORE_UNITS+MAX_ALLIED_UNITS+MAX_AUX_UNITS];

long icon_addr[MAX_ICONS];
BITMAP *til_bmp[MAX_TILES];
BITMAP *unit_bmp[MAX_UICONS];
BITMAP *flag_bmp[MAX_FLAGS];


int scn_number;
int hslide_max,vslide_max; //max position is defined by size of map...in load
int pix_pos,max_pix_x,max_pix_y;
char til_file[]="tacmap.shp";
char uicons_file[]="tacicons.shp";
char equip_file[]="panzequp.eqp";
char flag_file[]="flags.shp";
char names_file[]="Mapnames.str";
int total_tiles;
int total_uicons;
int total_units;  //in on the map
int total_equip; //units on panzequip
int total_flags;

struct VICTORY_HEXES victory_hexes[20];
struct DEPLOY_HEXES deploy_hexes[MAX_DEPLOY_HEXES];

//units in the scenario
int total_core;
int total_allied;
int total_aux;

int total_deploy; //deployment hexes

int mapx,mapy;  //the mapsize
int x0,y0;  //upper left of map
int x0temp,y0temp; //used during tile selection
int show_air; //toggle depending on whether air or gound selected
int map_mouse_x,map_mouse_y; //coordinates of map where mouse is

char gln[MAX_NAMES][20];
char unit_names[18][16]={
  "Infantry", "Tank","Recon","Anti-tank","Artillery",
  "Anti-aircraft","Air Defense","Fortification",
  "Fighter", "Tactical Bomber", "Level Bomber",
  "Submarine","Destroyer","Capital Ship", "Air. Carrier",
  "Land Transport","Air Transport","Sea Transport"};
char country_names[25][16]={
   "None","Austria","Belgium","Bulgaria","Holland", //0-4
   "Denmark","Finland","France","Germany","Greece", //5-9
   "United States","Hungary","Turkey","Italy","Luxembourg", //10-14
   "Norway","Poland","Portugal","Rumania","Spain", //15-19
   "Soviet Union","Sweden","Switzerland","United Kingdom","Yugoslavia"//20-24
};
int unit_type_selected; //picked in the ud dialog
int unum_selected; //the current unit for select and placement
int tnum_selected; //the current transport
int cnum_selected; //the current country
int anum_selected;
int ustr_selected;
int uent_selected;
int uexp_selected;

char uselected[16]="0";  //an ascii number for the current unit to be placed
char tselected[16]="0";  //an ascii number for its transport
char cselected[16]="0";  //an ascii number for the country
char aselected[16]="0";  //an ascii auxtransport number

struct UNIT selected_unit;

/* a PG palette...not that RGB values for allegro have and extra character */
RGB pgpal[256]={
 0, 0, 0,0,  0,36,49,0,  0,42, 0,0,  0,42,42,0, 42, 0, 0,0,  // 0-4
42, 0,42,0, 42,21, 0,0, 42,42,42,0, 21,21,21,0, 21,21,63,0,  // 5-9
21,63,21,0, 21,63,63,0, 63,21,21,0, 63,21,63,0, 63,63,21,0,  // 10-14
63,63,63,0, 19, 0, 0,0, 26, 0, 0,0, 33, 0, 0,0, 41, 1, 0,0,  // 15-19
48, 2, 0,0, 55, 4, 0,0, 63, 0, 0,0, 63,20, 4,0, 63,32, 9,0,  // 20-24
63,43,14,0, 63,52,19,0, 63,60,24,0, 60,63,30,0, 63,63,63,0,  // 25-29
55,58,55,0, 48,52,48,0, 41,47,41,0, 34,42,34,0, 29,37,29,0,  // 30-34
23,32,23,0, 18,27,18,0, 14,22,14,0, 10,17,10,0, 63,63,63,0,  // 35-39
56,57,60,0, 53,54,58,0, 50,52,57,0, 47,49,56,0, 45,47,55,0,  // 40-44
42,45,54,0, 40,43,52,0, 37,40,51,0, 34,38,50,0, 32,36,49,0,  // 45-49
30,34,47,0, 28,32,46,0, 26,30,45,0, 24,29,44,0, 22,27,43,0,  // 50-54
63,63,63,0, 57,59,59,0, 52,54,54,0, 47,50,50,0, 42,46,46,0,  // 55-59
37,42,42,0, 33,38,38,0, 29,34,34,0, 24,30,30,0, 21,26,26,0,  // 60-64
17,22,22,0, 13,18,18,0, 10,14,14,0,  7,10,10,0,  3, 6, 6,0,  // 65-69
 1, 2, 2,0, 63,60,35,0, 61,57,33,0, 59,54,31,0, 57,52,30,0,  // 70-74
56,49,29,0, 54,47,27,0, 52,44,26,0, 51,42,25,0, 46,48, 9,0,  // 75-79
62,60,41,0, 59,58,40,0, 56,56,39,0, 53,53,37,0, 49,50,36,0,  // 80-84
46,47,35,0, 43,44,33,0, 39,41,32,0, 36,38,30,0, 33,35,28,0,  // 85-89
55,54,30,0, 51,51,29,0, 48,48,29,0, 44,44,28,0, 40,41,27,0,  // 90-94
37,38,26,0, 34,35,25,0, 31,32,23,0, 28,29,22,0, 48,48,29,0,  // 95-99
12, 9, 6,0, 13,10, 7,0, 15,11, 8,0, 17,13, 9,0, 18,14,10,0,  // 100-104
20,16,10,0, 22,17,12,0, 23,19,13,0, 25,20,14,0, 27,22,15,0,  // 105-109
47,32,11,0, 56, 0,63,0, 63,63,15,0, 63,21,63,0, 27,22,15,0,  // 110-114
28,23,16,0, 63,21,63,0, 63,21,63,0, 34,29,20,0, 63,63,21,0,  // 115-119
 0,42, 0,0, 21,21,63,0,  0, 0,42,0, 33,35,28,0, 39,41,32,0,  // 120-124
 7,55,63,0, 50,52,57,0, 57,52,42,0, 14, 0, 0,0, 20, 0, 0,0,  // 125-129
25, 0, 0,0, 31, 1, 0,0, 36, 2, 0,0, 41, 3, 0,0, 47, 0, 0,0,  // 130-134
47,15, 3,0, 47,24, 7,0, 47,32,11,0, 47,39,14,0, 47,45,18,0,  // 135-139
45,47,23,0, 47,47,47,0, 41,44,41,0, 36,39,36,0, 31,35,31,0,  // 140-144
26,32,26,0, 22,28,22,0, 17,24,17,0, 14,20,14,0, 11,17,11,0,  // 145-149
 8,13, 8,0, 47,47,47,0, 42,43,45,0, 40,41,44,0, 38,39,43,0,  // 150-154
35,37,42,0, 34,35,41,0, 32,34,41,0, 30,32,39,0, 28,30,38,0,  // 155-159
26,29,38,0, 24,27,37,0, 23,26,35,0, 21,24,35,0, 20,23,34,0,  // 160-164
18,22,33,0, 17,20,32,0, 47,47,47,0, 43,44,44,0, 39,41,41,0,  // 165-169
35,38,38,0, 32,35,35,0, 28,32,32,0, 25,29,29,0, 22,26,26,0,  // 170-174
18,23,23,0, 16,20,20,0, 13,17,17,0, 10,14,14,0,  8,11,11,0,  // 175-179
 5, 8, 8,0,  2, 5, 5,0,  1, 2, 2,0, 47,45,26,0, 46,43,25,0,  // 180-184
44,41,23,0, 43,39,23,0, 42,37,22,0, 41,35,20,0, 39,33,20,0,  // 185-189
38,32,19,0, 35,36, 7,0, 47,45,31,0, 44,44,30,0, 42,42,29,0,  // 190-194
40,40,28,0, 37,38,27,0, 35,35,26,0, 32,33,25,0, 29,31,24,0,  // 195-199
27,29,23,0, 25,26,21,0, 41,41,23,0, 38,38,22,0, 36,36,22,0,  // 200-204
33,33,21,0, 30,31,20,0, 28,29,20,0, 26,26,19,0, 23,24,17,0,  // 205-209
21,22,17,0, 36,36,22,0, 36,31,21,0, 38,33,22,0, 40,35,23,0,  // 210-214
63,21,63,0, 63,21,63,0, 46,41,28,0, 48,43,29,0, 50,45,31,0,  // 215-219
52,47,32,0, 54,49,34,0, 35,22, 7,0, 63,21,63,0, 47,47,28,0,  // 220-224
63,21,63,0, 63,21,63,0, 57,53,36,0, 59,55,38,0, 61,57,40,0,  // 225-229
63,59,42,0, 47,47,16,0,  0,32, 0,0, 16,16,47,0,  0, 0,32,0,  // 230-234
25,26,21,0, 29,31,24,0, 17,41,47,0, 38,39,43,0, 43,39,32,0,  // 235-239
33,35,28,0, 39,41,32,0, 63, 8, 8,0, 10,49,45,0, 10,42,49,0,  // 240-244
10,31,49,0, 10,20,49,0, 11,10,49,0, 22,10,49,0, 33,10,49,0,  // 245-249
44,10,49,0, 49,10,43,0, 49,10,32,0, 49,10,21,0, 49,10,10,0,  // 250-254
 0, 0, 0,0 };

//this is the first part of the set file...we need to modify
//bytes 101 and 103 for the size of the map and bytes 51/52 and
//84/86 for the 2 digit ascii number of the map
unsigned char  set_head[]= {
     0x01,0x2E,0x2E,0x5C,0x64,0x61,0x74,0x5C,0x74,0x61,  // 1-10
     0x63,0x6D,0x61,0x70,0x2E,0x73,0x68,0x70,0x00,0x00,  // 11-20
     0x00,0x2E,0x2E,0x5C,0x64,0x61,0x74,0x5C,0x74,0x61,  // 21-30
     0x63,0x6D,0x61,0x70,0x2E,0x74,0x67,0x66,0x00,0x00,  // 31-40
     0x00,0x2E,0x2E,0x5C,0x64,0x61,0x74,0x5C,0x6D,0x61,  // 41-50
     0x70,0x30,0x32,0x2E,0x73,0x74,0x6D,0x00,0x00,0x00,  // 51-60
     0x00,0x2E,0x2E,0x5C,0x64,0x61,0x74,0x5C,0x6D,0x61,  // 61-70
     0x70,0x63,0x6F,0x6E,0x76,0x2E,0x73,0x74,0x67,0x00,  // 71-80
     0x00,0x6D,0x61,0x70,0x30,0x32,0x00,0x00,0x00,0x00,  // 81-90
     0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  // 91-100
     0x00,0x14,0x00,0x11,0x00,0x00,0x01,0x01,0x00,0x00,  // 101-110
     0x01,0x01,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01,  // 111-120
     0x01,0x01,0x00};


/* ---------------------- Functions ------------------------------------ */
//copy unit
void copy_unit(struct UNIT *dest, struct UNIT *src)
{
   dest->unum=src->unum;
   dest->orgtnum=src->orgtnum;
   dest->country=src->country;
   dest->auxtnum=src->auxtnum;
   dest->x=src->x;
   dest->y=src->y;
   dest->str=src->str;
   dest->entrench=src->entrench;
   dest->exp=src->exp;
   dest->uflag=src->uflag;
}

//remove the ground unit at x,y on the map
//and the array
void remove_gunit(int x,int y)
{
  int i,idx,mx,my;

  idx=map[x][y].guidx;
  if (idx>=0)  //there is a unit
  {
    map[x][y].guidx=-1;
    all_units[idx].unum=-1;
    for (i=0; i<total_units-1; ++i)
    {
      if (all_units[i].unum<=0)
      {
         copy_unit(&(all_units[i]),&(all_units[i+1]));
         all_units[i+1].unum=-1; //unit deleted
      }
    } //end for i
  }
  //now need to correct the map indexes
  for (mx=0; mx<mapx; ++mx)
   for (my=0; my<mapy; ++my)
   {
      if (map[mx][my].guidx>idx) --map[mx][my].guidx>idx;
      if (map[mx][my].auidx>idx) --map[mx][my].auidx>idx;
   }

}

//remove the air unit at x,y on the map
//and the array
void remove_aunit(int x,int y)
{
  int i,idx,mx,my;

  idx=map[x][y].auidx;
  if (idx>=0)  //there is a unit
  {
    map[x][y].auidx=-1;
    all_units[idx].unum=-1;
    for (i=0; i<total_units; ++i)
    {
      if (all_units[i].unum<=0)
      {
         copy_unit(&(all_units[i]),&(all_units[i+1]));
         all_units[i+1].unum=-1; //unit deleted
      }
    }
  }
  //now need to correct the map indexes
  for (mx=0; mx<mapx; ++mx)
   for (my=0; my<mapy; ++my)
   {
      if (map[mx][my].guidx>idx) --map[mx][my].guidx>idx;
      if (map[mx][my].auidx>idx) --map[mx][my].auidx>idx;
   }
}

int d_coreRB_proc(int msg, DIALOG *d, int c)
{
   if (msg==MSG_CLICK)
   {
     if (&(dm[dmCoreRBIdx])==d) ubelongs=core;
     if (&(dm[dmAuxRBIdx])==d) ubelongs=aux;
     if (&(dm[dmAlliedRBIdx])==d) ubelongs=allied;

   }
   return d_radio_proc(msg,d,c);
}

int d_mapinfo_proc(int msg,DIALOG *d,int c)
{
   return d_textbox_proc(msg,d,c);
}
int d_mapstatus_proc(int msg,DIALOG *d,int c)
{
   return d_textbox_proc(msg,d,c);
}

void strength_click()
{
  int x,y,gidx,aidx;

  x=map_mouse_x; y=map_mouse_y;
  gidx=map[x][y].guidx; aidx=map[x][y].auidx;

  //left click with ground units showing and unit there
  if (mouse_b&1 && !show_air && gidx>=0)
    if (all_units[gidx].str<15) ++all_units[gidx].str;
  //left click fro air unit
  if (mouse_b&1 && show_air && aidx>+0)
    if (all_units[aidx].str<15) ++all_units[aidx].str;
  //rigt click on ground
  if (mouse_b&2 && !show_air && gidx>=0)
    if (all_units[gidx].str>1) --all_units[gidx].str;
  //right click on  air
  if (mouse_b&2 && show_air && aidx>=0) //there's an air unit
    if (all_units[aidx].str>1)  --all_units[aidx].str;

}

void experience_click()
{
  int x,y,gidx,aidx;

  x=map_mouse_x; y=map_mouse_y;
  gidx=map[x][y].guidx; aidx=map[x][y].auidx;

  //left click with ground units showing and unit there
  if (mouse_b&1 && !show_air && gidx>=0)
    if (all_units[gidx].exp<5) ++all_units[gidx].exp;
  //left click fro air unit
  if (mouse_b&1 && show_air && aidx>+0)
    if (all_units[aidx].exp<5) ++all_units[aidx].exp;
  //rigt click on ground
  if (mouse_b&2 && !show_air && gidx>=0)
    if (all_units[gidx].exp>0) --all_units[gidx].exp;
  //right click on  air
  if (mouse_b&2 && show_air && aidx>=0) //there's an air unit
    if (all_units[aidx].exp>0)  --all_units[aidx].exp;



}

void entrench_click()
{
  int x,y,gidx;

  x=map_mouse_x; y=map_mouse_y;
  gidx=map[x][y].guidx;

  //left click with ground units showing and unit there
  if (mouse_b&1 && !show_air && gidx>=0)
    if (all_units[gidx].entrench<9) ++all_units[gidx].entrench;
  //rigt click on ground
  if (mouse_b&2 && !show_air && gidx>=0)
    if (all_units[gidx].entrench>0) --all_units[gidx].entrench;
}

void victory_click()
{
  int x,y,gidx;

  x=map_mouse_x; y=map_mouse_y;

  //left click
  if (mouse_b&1) map[x][y].vic=1;
  //right click
  if (mouse_b&2) map[x][y].vic=0;
  sprintf(MapStatusTxt,
        "Editing Victory Hexes \n Now %d of %d Max\n",
            count_vic_hexes(),MAX_VICTORY_HEXES);
  strcat(MapStatusTxt,"Left Click to add\nRight Click to remove");
  draw_map();
  broadcast_dialog_message(MSG_DRAW,0);

}

void neutral_click()
{
  int x,y,gidx;

  x=map_mouse_x; y=map_mouse_y;

  //left click
  if (mouse_b&1) map[x][y].side=3;
  //right click
  if (mouse_b&2) map[x][y].side=0;
  draw_map();
  broadcast_dialog_message(MSG_DRAW,0);

}

void deploy_click()
{
  int x,y,gidx;

  x=map_mouse_x; y=map_mouse_y;

  //left click
  if (mouse_b&1) map[x][y].deploy=1;
  //right click
  if (mouse_b&2) map[x][y].deploy=0;
  sprintf(MapStatusTxt,
        "Editing Deployment Hexes \n Now %d of %d Max\n",
            count_deploy_hexes(),MAX_DEPLOY_HEXES);
  strcat(MapStatusTxt,"Left Click to add\nRight Click to remove");
  draw_map();
  broadcast_dialog_message(MSG_DRAW,0);
}

void owner_click()
{
  int x,y;

  x=map_mouse_x; y=map_mouse_y;

  //left click
  if (mouse_b&1)
  {
    map[x][y].own=scn_buffer[0];
    map[x][y].side=0;
  }
  //right click
  if (mouse_b&2)
  {
    map[x][y].own=scn_buffer[1];
    map[x][y].side=1;
  }
  sprintf(MapStatusTxt,
        "Editing Owners\n");
  strcat(MapStatusTxt,"Left Click Axis \nRight Click Allied");
  draw_map();
  d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
}

do_place_status()
{
char line1[64],line2[64];

    strcpy(MapStatusTxt,"Left Click  to place\nRight Click to remove");
    sprintf(line1,"\n%s/%s",
      &(equip[unum_selected][NAME]),&(equip[tnum_selected][NAME]));
    strcat(MapStatusTxt,line1);
    sprintf(line1,"\nAux. T. %s",&(equip[anum_selected][NAME]));
    strcat(MapStatusTxt,line1);
    sprintf(line2,"\n(str=%d exp=%d ent=%d)",
        ustr_selected,uexp_selected,uent_selected);
    strcat(MapStatusTxt,line2);

}

int place_click()
{
   int idx,x,y;
   enum {none, air, ground} utype;

   x=map_mouse_x; y=map_mouse_y; //save some typing
   // process a right click on a ground or air unit
   if ((map[x][y].guidx>=0||map[x][y].auidx>=0) && mouse_b&2)
   {
     //set the current place unit to this unit's data
     if (show_air) idx=map[x][y].auidx;
     else idx=map[x][y].guidx;
     unum_selected=all_units[idx].unum;
     tnum_selected=all_units[idx].orgtnum;
     anum_selected=all_units[idx].auxtnum;
     cnum_selected=all_units[idx].country;

     ustr_selected=all_units[idx].str;
     uexp_selected=all_units[idx].exp;
     uent_selected=all_units[idx].entrench;

     //get rid of the unit
     if(!show_air) remove_gunit(x,y);
     else remove_aunit(x,y);
     --total_units;
     do_place_status();
     d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
  }
  //-----end right click on unit --------------
  //-------- process a left click ---------------
  if (unum_selected<=0) utype=none;
  else if (equip[unum_selected][GAF]==1) utype=air;
  else utype=ground;
  //place a ground unit
  if (map[x][y].guidx<0 && !show_air && utype==ground && mouse_b&1)
  {
    all_units[total_units].unum=unum_selected;
    all_units[total_units].orgtnum=tnum_selected;
    all_units[total_units].country=cnum_selected;
    all_units[total_units].auxtnum=anum_selected;
    all_units[total_units].x=x;
    all_units[total_units].y=y;
    all_units[total_units].str=ustr_selected;
    all_units[total_units].entrench=uent_selected;
    all_units[total_units].exp=uexp_selected;
    all_units[total_units].uflag=ubelongs;
    map[x][y].guidx=total_units;
    ++total_units;
  }
  //place an air unit
  if (map[x][y].auidx<0 && show_air && utype==air && mouse_b&1)
  {
    all_units[total_units].unum=unum_selected;
    all_units[total_units].orgtnum=tnum_selected;
    all_units[total_units].country=cnum_selected;
    all_units[total_units].auxtnum=0;
    all_units[total_units].x=x;
    all_units[total_units].y=y;
    all_units[total_units].str=ustr_selected;
    all_units[total_units].entrench=uent_selected;
    all_units[total_units].exp=uexp_selected;
    all_units[total_units].uflag=ubelongs;
    map[x][y].auidx=total_units;
    ++total_units;
  }
  draw_map();
  broadcast_dialog_message(MSG_DRAW,0);

}
void pick_msg()
{
  sprintf(MapStatusTxt,"Pick an Operation",0);
  d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
}

void tile_click()
{
  int i;

  //a click transfers the tile bmp and cancels the op
   edit_op=none;
   dm[dmTileBtnIdx].flags^=D_SELECTED;
   d_btn_proc(MSG_DRAW,&(dm[dmTileBtnIdx]),0);
   sprintf(tdTNStr,"%d",map[map_mouse_x][map_mouse_y].tile);
   for (i=0; i<total_tiles; ++i)
      map[i%16][i/16].tile=temp[i];
   x0=x0temp; y0=y0temp;
   draw_map();
   d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
   sprintf(MapStatusTxt,"Pick an Operation",0);
   d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
}

void terrain_click()
{
  int x,y;

 x=map_mouse_x; y=map_mouse_y;

 if (mouse_b&1)
  {
    map[x][y].utr=atoi(tdTTStr);
    map[x][y].rc=atoi(tdRDStr);
    map[x][y].tile=atoi(tdTNStr);
    map[x][y].gln=atoi(tdGLNStr);
    map[x][y].side=atoi(tdSDStr);
    draw_map();
    d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
  }
  //right click
  if (mouse_b&2)
  {
    sprintf(tdTTStr,"%d",map[x][y].utr);
    sprintf(tdRDStr,"%d",map[x][y].rc);
    sprintf(tdTNStr,"%d",map[x][y].tile);
    sprintf(tdGLNStr,"%d",map[x][y].gln);
    sprintf(tdSDStr,"%d",map[x][y].side);
    setup_terrain_info();
    setup_terrain_info();
    d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
  }
}

int d_mapbmp_proc(int msg,DIALOG *d,int c)
{
    int column,row,X,Y,idx,v;
    char line1[64],line2[64],line3[64],line4[64];

    if (msg==MSG_DRAW)
    {
       scare_mouse();
       v=d_bitmap_proc(msg,d,c);
       unscare_mouse();
       return v;
    }
    //process mouse clicks according to the current edit op
    if (msg==MSG_CLICK)
    {
      if (edit_op==ent) entrench_click();
      if (edit_op==str) strength_click();
      if (edit_op==exp) experience_click();
      if (edit_op==place) place_click();
      if (edit_op==vic) victory_click();
      if (edit_op==deploy) deploy_click();
      if (edit_op==own) owner_click();
      if (edit_op==ter) terrain_click();
      if (edit_op==tile) tile_click();
      if (edit_op==neutral) neutral_click();
      map_mouse_x=-1; //force a redraw on idle of info

    } //end click msg

    if (msg==MSG_LOSTMOUSE)
    {
      MapInfoTxt[0]=0;
      d_mapinfo_proc(MSG_DRAW,&(dm[dmMapInfoTxtIdx]),0);
      return d_bitmap_proc(msg,d,c);
    }

    if (msg==MSG_IDLE && mouse_x<dm[dmMapBmpIdx].w
                     && mouse_y>dm[dmMapBmpIdx].y)
    {
       X=mouse_x; Y=mouse_y-LINE_2_Y;
       column=(X-8)/TILE_WIDTH;
       if (column<0) column=0;
       if (column%2) row=(Y-TILE_HEIGHT/2)/TILE_HEIGHT;
       else row=Y/TILE_HEIGHT;
       column+=x0; row+=y0;
       if (column!=map_mouse_x || row!=map_mouse_y)
       {
         map_mouse_x=column; map_mouse_y=row;
         sprintf(line1,"%2d,%2d %s\n",
           map_mouse_x,map_mouse_y,
           gln[map[map_mouse_x][map_mouse_y].gln]);

          sprintf(line2, "(%2d,%2Xh,%3d,%4d,%d)\n",
           map[map_mouse_x][map_mouse_y].utr,
           map[map_mouse_x][map_mouse_y].rc,
           map[map_mouse_x][map_mouse_y].tile,
           map[map_mouse_x][map_mouse_y].gln,
           map[map_mouse_x][map_mouse_y].side);
          //now we take care of the unit info
          line3[0]=0; line4[0]=0;
          if(show_air==1 && map[map_mouse_x][map_mouse_y].auidx>=0) //air unit visible and present
          {
             idx=map[map_mouse_x][map_mouse_y].auidx;
             if (all_units[idx].uflag==core)
               sprintf(line3,"+%s\n", equip[all_units[idx].unum]);
             else
               sprintf(line3,"%s\n", equip[all_units[idx].unum]);


             sprintf(line4,"(str %d,exp %d,ent %d)",all_units[idx].str,
                  all_units[idx].exp, all_units[idx].entrench);

          }
          if(show_air==0 && map[map_mouse_x][map_mouse_y].guidx>=0) //ground unit visible and present
          {
            idx=map[map_mouse_x][map_mouse_y].guidx;
            if (all_units[idx].uflag==core)
              sprintf(line3,"+%s", equip[all_units[idx].unum]);
            else
              sprintf(line3,"%s", equip[all_units[idx].unum]);
            if (all_units[idx].orgtnum>0)
              sprintf(line4,"/%s\n",equip[all_units[idx].orgtnum]);
             else
              sprintf(line4,"\n");
            strcat(line3,line4);
            sprintf(line4,"(str %d,exp %d,ent %d)",all_units[idx].str,
                  all_units[idx].exp,all_units[idx].entrench);
          }

          MapInfoTxt[0]=0;
          strcat(MapInfoTxt,line1);
          strcat(MapInfoTxt,line2);
          strcat(MapInfoTxt,line3);
          strcat(MapInfoTxt,line4);
          d_mapinfo_proc(MSG_DRAW,&(dm[dmMapInfoTxtIdx]),0);
       }
    }
    return d_bitmap_proc(msg,d,c);
}


int d_GndAir_proc(int msg,DIALOG *d,int c)
{
  int i;
  if (msg==MSG_CLICK)  //calls for each button
  {
     if (&(dm[dmAirRBIdx])==d)
     show_air=1;
     else show_air=0;
     draw_map();
     d_bitmap_proc(MSG_DRAW,&dm[dmMapBmpIdx],c);
  }
  return d_radio_proc(msg,d,c);
}

int d_hslide_proc(int msg,DIALOG *d, int c)
{
   if (msg!=MSG_CLICK) return d_slider_proc(msg,d,c);
   //process the click on the horizontal slider
     d_slider_proc(msg,d,c);
     x0=d->d2;
     if (x0%2) --x0;
     draw_map();
     d_bitmap_proc(MSG_DRAW,&dm[dmMapBmpIdx],c);
     return D_O_K;
}

int d_vslide_proc(int msg,DIALOG *d, int c)
{
   if (msg!=MSG_CLICK) return d_slider_proc(msg,d,c);
   //process the click on the horizontal slider
   d_slider_proc(msg,d,c);
   y0=d->d1-d->d2; //high d2 is at top !!!
   draw_map();
   d_bitmap_proc(MSG_DRAW,&dm[dmMapBmpIdx],c);
   return D_O_K;
}

int count_core()
{
  int i,count=0;

  for(i=0; i<total_units; ++i)
    if (all_units[i].uflag==core) ++count;
  return count;
}

void get_victory_hexes()
{
   int i,idx,count,x,y;
 //empty the victory hex array
   for (i=0; i<20; ++i)
   {
     victory_hexes[i].x=-1;
     victory_hexes[i].y=-1;
   }
   //get the victory hexes from the map
   //and put them in the array, then in the scn_buffer
   count=0;
   for (x=0; x<mapx; ++x)
    for (y=0; y<mapy; ++y)
    {
      if (map[x][y].vic && count<20)
      {
         victory_hexes[count].x=x;
         victory_hexes[count].y=y;
         ++count;
      }
    }



}

int count_aux()
{
  int i,count=0;

  for(i=0; i<total_units; ++i)
    if (all_units[i].uflag==aux) ++count;
  return count;
}

int count_allied()
{
  int i,count=0;

  for(i=0; i<total_units; ++i)
    if (all_units[i].uflag==allied) ++count;
  return count;
}
//write the unit dat in all_units[i] to outf
void write_unit(FILE *outf,int i)
{
  fwrite(&(all_units[i].unum),2,1,outf);
  fwrite(&(all_units[i].orgtnum),2,1,outf);
  fwrite(&(all_units[i].country),1,1,outf);
  fwrite(&(all_units[i].auxtnum),2,1,outf);
  fwrite(&(all_units[i].x),2,1,outf);
  fwrite(&(all_units[i].y),2,1,outf);
  fwrite(&(all_units[i].str),1,1,outf);
  fwrite(&(all_units[i].entrench),1,1,outf);
  fwrite(&(all_units[i].exp),1,1,outf);

}

int save_set(int n)
{
   FILE *outf;
   int x,y,i;
   char fname[64];
   char scn_str[8];

   sprintf(fname,"Map%02d.set",n);
   outf=fopen(fname,"wb");
   if (!outf) return 1;

   //fix up the header
   set_head[101]=mapx-1;
   set_head[103]=mapy-1;
   sprintf(scn_str,"%02d",scn_number); //temp XXXX????
   set_head[51]=scn_str[0];
   set_head[52]=scn_str[1];
   set_head[84]=scn_str[0];
   set_head[85]=scn_str[1];

   //write the header
   for (i=0; i<sizeof(set_head); ++i)
     fputc(set_head[i],outf);
   //write section 1n GLN
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
     {
        fputc(map[x][y].gln&255,outf);
        fputc(map[x][y].gln/256,outf);
     }
   // road connectivity
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
        fputc(map[x][y].rc&255,outf);
   // country owners
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
        fputc(map[x][y].own&255,outf);
   // side info i.e. axis.allied.unown.neutral
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
        fputc(map[x][y].side&255,outf);
  // tile numbers
  for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
     {
        fputc(map[x][y].tile&255,outf);
        fputc(map[x][y].tile/256,outf);
     }
   
   fclose(outf);
   return 0;
}

int save_stm(int n)
{
   FILE *outf;
   int x,y;
   char fname[64];

   sprintf(fname,"Map%02d.stm",n);
   outf=fopen(fname,"wb");
   if (!outf) return 1;
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
     {
        fputc(map[x][y].utr&255,outf);
        fputc(map[x][y].utr/256,outf);
     }
   fclose(outf);
   return 0;
}

int save_scenario(int n)
{
   char fname[32];
   FILE *outf;
   int deploy_size,units_start,i;
   int s4_starts,x,y,count,idx;

   total_core=count_core();
   total_aux=count_aux();
   total_allied=count_allied();

   scn_buffer[CORE_UNITS]=total_core;
   scn_buffer[AUX_UNITS]=total_aux;
   scn_buffer[ALLIED_UNITS]=total_allied;
  //read the victory hexes from the map
  get_victory_hexes();
  //now place in the scen buffer
  idx=VIC_HEXES;
  for (i=0; i<20; ++i)
  {
     scn_buffer[idx+0]=victory_hexes[i].x&255;
     scn_buffer[idx+1]=(victory_hexes[i].x>>8)&255;
     scn_buffer[idx+2]=victory_hexes[i].y&255;
     scn_buffer[idx+3]=(victory_hexes[i].y>>8)&255;
     idx+=4;
  }
   // open the file...
   sprintf(fname,"Game%03d.scn",n);
   outf=fopen(fname,"wb");
   if (!outf)
   {
      sprintf(MapStatusTxt,"Save of %s FAILED",fname);
      return 1;
   }
   for (i=0; i<DEPLOY_TABLE; ++i)
      fputc(scn_buffer[i],outf);
   deploy_size=count_deploy_hexes();    //this is the present size
   fputc((deploy_size+1)&255,outf);
   fputc(0,outf);
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
     if (map[x][y].deploy)
     {
        fputc(x,outf); fputc(0,outf);
        fputc(y,outf); fputc(0,outf);
     }
   for (i=0; i<4; ++i)
     fputc(255,outf);
   //now use the old deploy size in the buffer to find the rest of the data
   deploy_size=4*(scn_buffer[DEPLOY_TABLE]+256*scn_buffer[DEPLOY_TABLE+1]);
   units_start=deploy_size+0x87;  //this is the old size
   s4_starts=deploy_size+0x77;
   //write the first section
  // for (i=0; i<s4_starts; ++i)
  //   fputc(scn_buffer[i],outf);

   //write the s4_buffer
   for (i=0; i<16; ++i)
     fputc(s4_buffer[i],outf);
   //write core
   for(i=0; i<total_units; ++i)
   {
     if (all_units[i].uflag==core)
       write_unit(outf,i);
   }
   //write aux
   for(i=0; i<total_units; ++i)
   {
     if (all_units[i].uflag==aux)
       write_unit(outf,i);
   }
   //write allied
   for(i=0; i<total_units; ++i)
   {
     if (all_units[i].uflag==allied)
       write_unit(outf,i);
   }
   fclose(outf);
   sprintf(MapStatusTxt,"%s Saved",fname);
   return 0;
}

void setup_terrain_info()
{
         strcpy(MapStatusTxt,"Terrain Edit: ");
         strcat(MapStatusTxt,"Type=");
         strcat(MapStatusTxt,tdTTStr);
         strcat(MapStatusTxt,"\nRoad=");
         strcat(MapStatusTxt,tdRDStr);
         strcat(MapStatusTxt,"  Tile#=");
         strcat(MapStatusTxt,tdTNStr);
         strcat(MapStatusTxt,"\nName=");
         strcat(MapStatusTxt,tdGLNStr);
         strcat(MapStatusTxt,"  Side=");
         strcat(MapStatusTxt,tdSDStr);
         strcat(MapStatusTxt,"\nLeft-change Right-pick");
}

int d_btn_proc(int msg,DIALOG *d, int c)
{
  int i;
  static int idle_flag;



  //we will intercept the click message. whenever a button
  //is pressed, we will unselect all the buttons and
  //do cleanup as needed. Then we will do the action for
  //the button pressed
  if (msg==MSG_CLICK)
  {
     edit_op=none; idle_flag=0;
     // deploy button
     if (dm[dmDeployBtnIdx].flags&D_SELECTED)
      {
         //cleanup the deploy button ...
         draw_map();
         d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
         //reset the button
         dm[dmDeployBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmDeployBtnIdx]),0);
      }
      // neutral button
     if (dm[dmNeutralBtnIdx].flags&D_SELECTED)
      {
         //cleanup the neutral button ...
         draw_map();
         d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
         //reset the button
         dm[dmNeutralBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmNeutralBtnIdx]),0);
      }
     //Victory Button
     if (dm[dmVictBtnIdx].flags&D_SELECTED)
      {
         //cleanup the victory button ...
         draw_map();
         d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
         //reset the button
         dm[dmVictBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmVictBtnIdx]),0);
      }
     //Owner
     if (dm[dmOwnBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Own button ...

         //reset the button
         dm[dmOwnBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmOwnBtnIdx]),0);
      }
     //Terrain
     if (dm[dmTerBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Terrain button ...

         //reset the button
         dm[dmTerBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmTerBtnIdx]),0);
      }
     //Tiles
     if (dm[dmTileBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Tiles button ...
        //restore things
          for (i=0; i<total_tiles; ++i)
            map[i%16][i/16].tile=temp[i];
          x0=x0temp; y0=y0temp;
          draw_map();
          pick_msg();
          d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
         // sprintf(MapStatusTxt,"Pick an Operation",0);
         // d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
         //reset the button
         dm[dmTileBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmTileBtnIdx]),0);
      }
     //Entrench
     if (dm[dmEntBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Entrench button ...

         //reset the button
         dm[dmEntBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmEntBtnIdx]),0);
      }
      // Strength
      if (dm[dmStrBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Strength button ...

         //reset the button
         dm[dmStrBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmStrBtnIdx]),0);
      }
      // Experience
      if (dm[dmExpBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Experience button ...

         //reset the button
         dm[dmExpBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmExpBtnIdx]),0);
      }
      // Place unit
      if (dm[dmPlaceBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Place button ...

         //reset the button
         dm[dmPlaceBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmPlaceBtnIdx]),0);
      }
      //Unit edit
      if (dm[dmUnitBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Unit button ...

         //reset the button
         dm[dmUnitBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmUnitBtnIdx]),0);
      }
      //Scen edit
      if (dm[dmScenBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Scen button ...

         //reset the button
         dm[dmScenBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmScenBtnIdx]),0);
      }
      //Load
      if (dm[dmLoadBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Load button ...

         //reset the button
         dm[dmLoadBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmLoadBtnIdx]),0);
      }
      //Save
      if (dm[dmSaveBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Save button ...

         //reset the button
         dm[dmSaveBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmSaveBtnIdx]),0);
      }
      //Exit
      if (dm[dmExitBtnIdx].flags&D_SELECTED)
      {
         //cleanup the Exit button ...

         //reset the button
         dm[dmExitBtnIdx].flags^=D_SELECTED;
         pick_msg();
         return d_button_proc(MSG_DRAW,&(dm[dmExitBtnIdx]),0);
      }
  //------------ end of unselect -------------------------
  //-------- now do the setup for each button ------------
     // neutral button
     if (d==&(dm[dmNeutralBtnIdx]))
      {
         //setup the deploy button ...
        edit_op=neutral;
        draw_map();
        sprintf(MapStatusTxt,
        "Editing Neutal Hexes \n");
        strcat(MapStatusTxt,"Left Click to add\nRight Click to remove");
        broadcast_dialog_message(MSG_DRAW,0);
      }

  // deploy button
     if (d==&(dm[dmDeployBtnIdx]))
      {
         //setup the deploy button ...
         edit_op=deploy;
        draw_map();
        sprintf(MapStatusTxt,
        "Editing Deployment Hexes \n Now %d of %d Max\n",
            count_deploy_hexes(),MAX_DEPLOY_HEXES);
        strcat(MapStatusTxt,"Left Click to add\nRight Click to remove");
        broadcast_dialog_message(MSG_DRAW,0);

      }

      // victory button
     if (d==&(dm[dmVictBtnIdx]))
     {
         //setup the victory button ...
         edit_op=vic;
        draw_map();
        sprintf(MapStatusTxt,
        "Editing Victory Hexes \n Now %d of %d Max\n",
            count_vic_hexes(),MAX_VICTORY_HEXES);
        strcat(MapStatusTxt,"Left Click to add\nRight Click to remove");
        broadcast_dialog_message(MSG_DRAW,0);
     }
     // owner button
     if (d==&(dm[dmOwnBtnIdx]))
     {
       edit_op=own;
       sprintf(MapStatusTxt,"Editing Hex Owners\n");
       strcat(MapStatusTxt,"Left Click for Axis\nRight Click for Allied");
       d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
     }
     // Terrain
     if (d==&(dm[dmTerBtnIdx]))
     {
       edit_op=ter;
       do_dialog(td,-1);
       setup_terrain_info();
       d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
       d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
       // force button draw...default doesn't seem to select
       dm[dmTerBtnIdx].flags^=D_SELECTED;

     }
     if (d==&(dm[dmTileBtnIdx]))
     {
         //we will temporarily display the complete
         //set of tile in the upper left corner...
         //a click will restore the map and transfer
         //the bmp # to
         if (mapx>15&&mapy>15) //too small ?
         {
           edit_op=tile;
           for (i=0; i<total_tiles; ++i)
           {
             temp[i]=map[i%16][i/16].tile;
             map[i%16][i/16].tile=i;
           }
           x0temp=x0; x0=0;
           y0temp=y0; y0=0;
           draw_map();
           d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
           sprintf(MapStatusTxt,"Tile set in Top Left\nClick the one you want.");
           d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);

         }
      }
      //entrench
      if (&(dm[dmEntBtnIdx])==d)  //entrench
      {
          edit_op=ent;
          strcpy(MapStatusTxt,"Left Click  + entrench\nRight Click - entrench");
          d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      //strength
      if (&(dm[dmStrBtnIdx])==d)  //strength
      {
        edit_op=str;
        strcpy(MapStatusTxt,"Left Click  + strength\nRight Click - strength");
        d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      //experience
      if (&(dm[dmExpBtnIdx])==d)   //experience
      {
        edit_op=exp;
        strcpy(MapStatusTxt,"Left Click  + experience\nRight Click - experience");
        d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      //place unit
      if (&(dm[dmPlaceBtnIdx])==d)   //place unit
      {
         edit_op=place;

         unum_selected=atoi(uselected);
         tnum_selected=atoi(tselected);
         cnum_selected=atoi(cselected);
         anum_selected=atoi(aselected);

         ustr_selected=10;
         uexp_selected=0;
         uent_selected=0;
         do_place_status();
         d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      //unit dialog
      if (&dm[dmUnitBtnIdx]==d)  //unit dialog
      {
         do_dialog(ud,-1);
         strcpy(MapStatusTxt,"Pick operation");
         broadcast_dialog_message(MSG_DRAW,0);
         return D_O_K; //don't let the button get selected
      }
      //scenario dialog
      if (dmScenBtnIdx==d->d1)  //scenario dialog
      {
         //count the units and store in scn_buffer first
         scn_buffer[CORE_UNITS]=count_core()&255;
         scn_buffer[AUX_UNITS]=count_aux()&255;
         scn_buffer[ALLIED_UNITS]=count_allied()&255;
         //update the victory hex array
         get_victory_hexes();
         do_dialog(sd,-1);
         strcpy(MapStatusTxt,"Pick operation");
         broadcast_dialog_message(MSG_DRAW,0);
         return D_O_K; //never gets selected
      }
      //Load
      if (&(dm[dmLoadBtnIdx])==d)
      {
         x0=0; y0=0;
         //clear the map
         memset(&map, 0, sizeof(map));
         read_map(scn_number);
         load_scn();
         rectfill(map_bmp,0,0,MAP_W,MAP_H,MAP_COLOR);

         draw_map();
         dm[dmLoadBtnIdx].flags^=D_SELECTED;
         sprintf(MapStatusTxt,"Scenario %d Loaded\nPick an Operation",
           scn_number);
         broadcast_dialog_message(MSG_DRAW,0);
      }
      //Save
      if (&(dm[dmSaveBtnIdx])==d)
      {
        save_scenario(0);
        save_stm(0);
        save_set(0);
        d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
        sprintf(MapStatusTxt,"Scenario Saved\nPick an Operation");
        d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
        dm[dmSaveBtnIdx].flags^=D_SELECTED;
      }

  }//end of process MSG_CLICK
  return d_button_proc(msg,d,c);
}
/*
int d_btn_proc(int msg,DIALOG *d, int c)
{
  int i,x,y;
  int reselect=1; //certain buttons...vic deploy..can't be reselected

  // make the function selection buttons act like radio buttons
  if (msg==MSG_CLICK)
  {
     // do radio button like redraw
     if (edit_op==vic||edit_op==deploy) //need to redraw the map
     {
       edit_op=none;
       draw_map();
       d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
       reselect=0;
     }
     edit_op=none;
     for (i=0; i<dm_OBJECTS; ++i)
     {
        if (dm[i].d1<dm_OBJECTS && dm[i].d1>0 && dm[i].flags&D_SELECTED)
        {
          dm[i].flags^=D_SELECTED;
          d_button_proc(MSG_DRAW,&(dm[i]),0);
        }

     }

     // button actions....

      if (dmUnitBtnIdx==d->d1)  //unit dialog
      {
         do_dialog(ud,-1);
         strcpy(MapStatusTxt,"Pick operation");
         broadcast_dialog_message(MSG_DRAW,0);
      }
      if (dmScenBtnIdx==d->d1)  //scenatio dialog
      {
         //count the units and store in scn_buffer first
         scn_buffer[CORE_UNITS]=count_core()&255;
         scn_buffer[AUX_UNITS]=count_aux()&255;
         scn_buffer[ALLIED_UNITS]=count_allied()&255;
         //update the victory hex array
         get_victory_hexes();
         do_dialog(sd,-1);
         strcpy(MapStatusTxt,"Pick operation");
         broadcast_dialog_message(MSG_DRAW,0);
      }
      if (&(dm[dmEntBtnIdx])==d)  //entrench
      {
         edit_op=ent;
         strcpy(MapStatusTxt,"Left Click  + entrench\nRight Click - entrench");
         d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      if (&(dm[dmStrBtnIdx])==d)  //strength
      {
         edit_op=str;
         strcpy(MapStatusTxt,"Left Click  + strength\nRight Click - strength");
         d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      if (&(dm[dmExpBtnIdx])==d)   //experience
      {
         edit_op=exp;
         strcpy(MapStatusTxt,"Left Click  + experience\nRight Click - experience");
         d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      if (&(dm[dmPlaceBtnIdx])==d)   //place unit
      {
         edit_op=place;

         unum_selected=atoi(uselected);
         tnum_selected=atoi(tselected);
         cnum_selected=atoi(cselected);
         anum_selected=atoi(aselected);

         ustr_selected=10;
         uexp_selected=0;
         uent_selected=0;
         do_place_status();
         d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      if (&(dm[dmLoadBtnIdx])==d)  //Load
      {
         x0=0; y0=0;
         //clear the map
         memset(&map, 0, sizeof(map));
         read_map(scn_number);
         load_scn();
         rectfill(map_bmp,0,0,MAP_W,MAP_H,MAP_COLOR);

         draw_map();
         dm[dmLoadBtnIdx].d1^=D_SELECTED;
         broadcast_dialog_message(MSG_DRAW,0);
      }
      if (&(dm[dmSaveBtnIdx])==d)   //Save
      {
        save_scenario(0);
        save_stm(0);
        save_set(0);
        d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
        //dm[dmSaveBtnIdx].d1^=D_SELECTED;
      }
      if (&(dm[dmVictBtnIdx])==d && reselect)   //Victory hex mode
      {
        edit_op=vic;
        draw_map();
        sprintf(MapStatusTxt,
        "Editing Victory Hexes \n Now %d of %d Max\n",
            count_vic_hexes(),MAX_VICTORY_HEXES);
        strcat(MapStatusTxt,"Left Click to add\nRight Click to remove");
        broadcast_dialog_message(MSG_DRAW,0);
        //d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      if (&(dm[dmDeployBtnIdx])==d&&reselect)   //Deployment hex mode
      {
        edit_op=deploy;
        draw_map();
        sprintf(MapStatusTxt,
        "Editing Deployment Hexes \n Now %d of %d Max\n",
            count_deploy_hexes(),MAX_DEPLOY_HEXES);
        strcat(MapStatusTxt,"Left Click to add\nRight Click to remove");
        broadcast_dialog_message(MSG_DRAW,0);
        //d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      if (&(dm[dmOwnBtnIdx])==d) //Owner hex mode
      {
         edit_op=own;
         sprintf(MapStatusTxt,"Editing Hex Owners\n");
        strcat(MapStatusTxt,"Left Click for Axis\nRight Click for Allied");
        d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
      }
      if (&(dm[dmTerBtnIdx])==d)  //Terrain
      {
         edit_op=ter;
         do_dialog(td,-1);
         setup_terrain_info();
         d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
         d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
         dm[dmTerBtnIdx].flags|=D_SELECTED;
      }
      if (&(dm[dmTileBtnIdx])==d)  //Show all the tiles at the top of the map
      {
         //we will temporarily display the complete
         //set of tile in the upper left corner...
         //a click will restore the map and transfer
         //the bmp # to
         if (dm[dmTileBtnIdx].flags&D_SELECTED) //this is a second click
         {
            //restore things
            for (i=0; i<total_tiles; ++i)
              map[i%16][i/16].tile=temp[i];
            x0=x0temp; y0=y0temp;
            draw_map();
            d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
            sprintf(MapStatusTxt,"Pick an Operation",0);
            d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
         }
         else
         if (mapx>15&&mapy>15) //too small...
         {
           edit_op=tile;
           for (i=0; i<total_tiles; ++i)
           {
             temp[i]=map[i%16][i/16].tile;
             map[i%16][i/16].tile=i;
           }
           x0temp=x0; x0=0;
           y0temp=y0; y0=0;
           draw_map();
           d_mapbmp_proc(MSG_DRAW,&(dm[dmMapBmpIdx]),0);
           sprintf(MapStatusTxt,"Tile set in Top Left\nClick the one you want.");
           d_mapstatus_proc(MSG_DRAW,&(dm[dmMapStatusIdx]),0);
         }
      }
      return d_button_proc(msg,d,c);
    } //end of process push clicks

    return d_button_proc(msg,d,c);
}
*/
int d_arrow_proc(int msg, DIALOG *d, int c)
{
    int tx,ty;

    if (msg!=MSG_CLICK) return d_bitmap_proc(msg,d,c);
    tx=x0; ty=y0;
    switch (d->d1)
    {
        case 'U': if (y0>0) --y0;
                  break;
        case 'D': if ((mapy-TILES_HIGH)>y0) ++y0;
                  break;
        case 'L': if (x0>0) x0-=2;
                  break;
        case 'R': if ((mapx-1-TILES_WIDE)>x0) x0+=2;
                  break;
    }
    if (tx!=x0 || ty!=y0) //avoid redraw if nothing changed
    {
      draw_map();
      dm[dmHSlideIdx].d2=x0;
      dm[dmVSlideIdx].d2=vslide_max-y0;
      d_slider_proc(MSG_DRAW,&dm[dmHSlideIdx],0);
      d_slider_proc(MSG_DRAW,&dm[dmVSlideIdx],0);
      d_bitmap_proc(MSG_DRAW,&dm[dmMapBmpIdx],c);
    }
    return d_bitmap_proc(msg,d,c);
}

// place the color number in the bmp image and bump pix_pos
void put_pix(BITMAP *bmp, int y, int clr)
{
  if (pix_pos>=max_pix_x) max_pix_x=pix_pos+1;  //some SP info
  if (y>=max_pix_y) max_pix_y=y+1;
  putpixel(bmp,pix_pos,y,clr);
  ++pix_pos;
}

// read the shp data (for icon n) into the bitmap image (bmp)
void read_shp(BITMAP *bmp, FILE *inf,long addr)
{
   int l; // first line the counter
   int lf; // last line
   int ch,b,r,i;

   fseek(inf,addr+HEADER_SIZE,0);
   if (header.ystart<0)
   {
    l=0; lf=header.yend+abs(header.ystart);   //SP...
   }
   else
   {
     l=header.ystart;
     lf=header.yend;
   }
   if (header.xstart<0)      //SP....
      pix_pos=0;
   else
    pix_pos=header.xstart;
   do
   {
     // read data  and decode
     ch=fgetc(inf);
     r=ch%2;
     b=ch/2;
     if (b==0 && r==1) // a skip over
     {
        ch=fgetc(inf);
        for (i=0; i<ch; ++i)
          put_pix(bmp,l,BK_COLOR);
     }
     else if (b==0)   // end of line
     {
       ++l;
       if (header.xstart<0)
       {
         pix_pos=0;
       }
       else pix_pos=header.xstart;
     }
     else if (r==0) // a run of bytes
     {
       ch=fgetc(inf); // the color #
       if (ch==0) ch=255;  //allegro uses color 0 as transparent (cf BK_COLOR)
       for (i=0; i<b; ++i)
        put_pix(bmp,l,ch);
     }
     else // b!0 and r==1 ... read the next b bytes as color #'s
     {
       for (i=0; i<b; ++i)
       {
         ch=fgetc(inf);
         if (ch==0) (ch=255);  //allegro uses color 0 as transparent (cf BK_COLOR)
         put_pix(bmp,l,ch);
       }
     }
   } while (l<=lf);
}

void read_header(FILE *shp,long addr)
{
   fseek(shp,addr,SEEK_SET);
   fread(&(header.lines),2,1,shp);
   fread(&(header.width),2,1,shp);
   fread(&(header.centerx),2,1,shp);
   fread(&(header.centery),2,1,shp);
   fread(&(header.xstart),4,1,shp);
   fread(&(header.ystart),4,1,shp);
   fread(&(header.xend),4,1,shp);
   fread(&(header.yend),4,1,shp);
}

//here we load tiles and create the bitmaps
//referenced by til_bmp[]. Return 0 on success
//an error code on failure
int load_tiles()
{
  FILE *inf;
  int i,x,y;

  inf=fopen(til_file,"rb");
  if (!inf)
  {
     allegro_exit();
     printf("\nCould not open tile file %s.\n",til_file);
     return 10;
  }
  fseek(inf,4,SEEK_SET);
  fread(&total_tiles,4,1,inf);
  if (total_tiles>MAX_TILES)
  {
     allegro_exit();
     printf("Maximum icon limit (%d) is exceeded!!!\n",MAX_TILES);
     return 11;
  }
  // read addresses
  for (i=0; i<total_tiles; ++i)
  {
    fseek(inf,8+8*i,SEEK_SET);
    fread(&(icon_addr[i]),4,1,inf);
  }
  //create the bitmap
  for (i=0; i<total_tiles; ++i)
  {
   til_bmp[i]=create_bitmap(60,50);
   if (!til_bmp[i])
   {
     allegro_exit();
     printf("\nCould not allocate tile bitmap %d\n",i);
     return 12;
   }

   // zero out the bitmap with the transparent color
   for (y=0; y<50; ++y)
     for (x=0; x<60; ++x)
       putpixel(til_bmp[i],x,y,0);
    //read in the data from the shp file
   read_header(inf,icon_addr[i]);
   read_shp(til_bmp[i],inf,icon_addr[i]);
  }
  fclose(inf);
  return 0;
}

//load the flags from the flag icon fil
int load_flags()
{
  FILE *inf;
  int i,x,y;

  inf=fopen(flag_file,"rb");
  if (!inf)
  {
     allegro_exit();
     printf("\nCould not open flag file %s.\n",flag_file);
     return 50;
  }
  fseek(inf,4,SEEK_SET);
  fread(&total_flags,4,1,inf);
  if (total_flags>MAX_TILES)
  {
     allegro_exit();
     printf("Maximum icon limit (%d) is exceeded!!!\n",MAX_TILES);
     return 51;
  }
  // read addresses
  for (i=0; i<total_flags; ++i)
  {
    fseek(inf,8+8*i,SEEK_SET);
    fread(&(icon_addr[i]),4,1,inf);
  }
  //create the bitmap
  for (i=0; i<total_flags; ++i)
  {
   flag_bmp[i]=create_bitmap(60,50);
   if (!flag_bmp[i])
   {
     allegro_exit();
     printf("\nCould not allocate tile bitmap %d\n",i);
     return 52;
   }

   // zero out the bitmap with the transparent color
   for (y=0; y<50; ++y)
     for (x=0; x<60; ++x)
       putpixel(flag_bmp[i],x,y,0);
    //read in the data from the shp file
   read_header(inf,icon_addr[i]);
   read_shp(flag_bmp[i],inf,icon_addr[i]);
  }
  fclose(inf);
  return 0;
}

int load_equip()
{
   int i;
   FILE *inf;

   inf=fopen(equip_file,"rb");
   if (!inf)
   {
      printf("Could not load equipment file\n");
      return 30;
   }
   fread(&total_equip,2,1,inf);
   if (total_units>MAX_UNITS)
   {
       printf("Could not load equipment file\n");
      return 31;
   }
   for (i=0; i<total_equip; ++i)
     fread(&(equip[i]),EQUIP_REC_SIZE,1,inf);
   fclose(inf);
   return 0;
}

//read the scenario into the buffer and load
//data into various storage variables
int load_scn()
{
  FILE *inf;
  int i,ch=0,units_start,idx;
  char fname[16];
  int unum,x,y;

  scn_size=0;
  sprintf(fname,"Game%03d.scn",scn_number);
  inf=fopen(fname,"rb");
  if (!inf)
  {
    printf("Couldn't open scenario file\n");
    return 40;
  }
  while ( (ch=fgetc(inf))!=EOF && scn_size<MAX_SCN_SIZE)
  {
     scn_buffer[scn_size]=ch;
     ++scn_size;
  }
  fclose(inf);
  if (scn_size>=MAX_SCN_SIZE) return 41;
  total_core=scn_buffer[CORE_UNITS];
  total_allied=scn_buffer[ALLIED_UNITS];
  total_aux=scn_buffer[AUX_UNITS];
  total_deploy=scn_buffer[DEPLOY_TABLE];
  units_start=total_deploy*4+DEPLOY_TO_UNITS;
  idx=units_start; //place in buffer
  total_units=0;
  //read the core
  for (i=0; i<total_core; ++i,++total_units)
  {
    all_units[i].unum=scn_buffer[idx+0]+256*scn_buffer[idx+1];
    all_units[i].orgtnum=scn_buffer[idx+2]+256*scn_buffer[idx+3];
    all_units[i].country=scn_buffer[idx+4];
    all_units[i].auxtnum=scn_buffer[idx+5]+256*scn_buffer[idx+6];
    all_units[i].x=scn_buffer[idx+7]+256*scn_buffer[idx+8];
    all_units[i].y=scn_buffer[idx+9]+256*scn_buffer[idx+10];
    all_units[i].str=scn_buffer[idx+11];
    all_units[i].entrench=scn_buffer[idx+12];
    all_units[i].exp=scn_buffer[idx+13];
    all_units[i].uflag=core;
    idx+=14;
  }

  //read the aux
  for (i=0; i<total_aux; ++i,++total_units)
  {
    all_units[total_units].unum=scn_buffer[idx+0]+256*scn_buffer[idx+1];
    all_units[total_units].orgtnum=scn_buffer[idx+2]+256*scn_buffer[idx+3];
    all_units[total_units].country=scn_buffer[idx+4];
    all_units[total_units].auxtnum=scn_buffer[idx+5]+256*scn_buffer[idx+6];
    all_units[total_units].x=scn_buffer[idx+7]+256*scn_buffer[idx+8];
    all_units[total_units].y=scn_buffer[idx+9]+256*scn_buffer[idx+10];
    all_units[total_units].str=scn_buffer[idx+11];
    all_units[total_units].entrench=scn_buffer[idx+12];
    all_units[total_units].exp=scn_buffer[idx+13];
    all_units[total_units].uflag=aux;
    idx+=14;
  }
  
  //read the allied
  for (i=0; i<total_allied; ++i,++total_units)
  {
    all_units[total_units].unum=scn_buffer[idx+0]+256*scn_buffer[idx+1];
    all_units[total_units].orgtnum=scn_buffer[idx+2]+256*scn_buffer[idx+3];
    all_units[total_units].country=scn_buffer[idx+4];
    all_units[total_units].auxtnum=scn_buffer[idx+5]+256*scn_buffer[idx+6];
    all_units[total_units].x=scn_buffer[idx+7]+256*scn_buffer[idx+8];
    all_units[total_units].y=scn_buffer[idx+9]+256*scn_buffer[idx+10];
    all_units[total_units].str=scn_buffer[idx+11];
    all_units[total_units].entrench=scn_buffer[idx+12];
    all_units[total_units].exp=scn_buffer[idx+13];
    all_units[total_units].uflag=allied;
    idx+=14;
  }

  //place the units in the map record
  for (i=0; i<total_units; ++i)
  {
     unum=all_units[i].unum;
     x=all_units[i].x;
     y=all_units[i].y;
     if (x>=mapx || y>=mapy || x<0 || y<0) //this is an error!
         return 44;
     if (equip[unum][GAF]) //1 if air unit
       map[x][y].auidx=i;
     else
       map[x][y].guidx=i;
  }


  //get the victory hex coordinate and place on map
  idx=VIC_HEXES;
  for (i=0; i<20; ++i)
  {
    victory_hexes[i].x=scn_buffer[idx+0];
    victory_hexes[i].y=scn_buffer[idx+2];
    if (victory_hexes[i].x>=MAX_MAP_X)
    {
       victory_hexes[i].x=-1;
       victory_hexes[i].y=-1;
    }
    else
    victory_hexes[i].own=map[victory_hexes[i].x][victory_hexes[i].y].own;
    idx+=4;
  }
  i=0;
  while (victory_hexes[i].x>=0)
  {
     map[victory_hexes[i].x][victory_hexes[i].y].vic=1;
     ++i;
  }
  idx=DEPLOY_TABLE+2;
  for (i=0; i<total_deploy; ++i)
  {
     x=scn_buffer[idx]; y=scn_buffer[idx+2];
     map[x][y].deploy=1;
     idx+=4;
  }
  //put the prestige and transport info in s4
  idx=scn_buffer[0x75]*4+0x77;
  for (i=0; i<16; ++i)
    s4_buffer[i]=scn_buffer[idx+i];

  return 0;
}


//here we load unit icons and create the bitmaps
//referenced by unit_bmp[]. Return 0 on success
//an error code on failure
int load_uicons()
{
  FILE *inf;
  int i,x,y;

  inf=fopen(uicons_file,"rb");
  if (!inf)
  {
     allegro_exit();
     printf("\nCould not open tile file %s.\n",til_file);
     return 20;
  }
  fseek(inf,4,SEEK_SET);
  fread(&total_uicons,4,1,inf);
  if (total_uicons>MAX_UICONS)
  {
     allegro_exit();
     printf("Maximum unit icon limit (%d) is exceeded!!!\n",MAX_UICONS);
     return 21;
  }
  // read addresses
  for (i=0; i<total_uicons; ++i)
  {
    fseek(inf,8+8*i,SEEK_SET);
    fread(&(icon_addr[i]),4,1,inf);
  }
  //create the bitmap
  for (i=0; i<total_uicons; ++i)
  {
   unit_bmp[i]=create_bitmap(60,50);
   if (!unit_bmp[i])
   {
     allegro_exit();
     printf("\nCould not allocate unit bitmap %d\n",i);
     return 22;
   }

   // zero out the bitmap with the transparent color
   for (y=0; y<50; ++y)
     for (x=0; x<60; ++x)
       putpixel(unit_bmp[i],x,y,0);
    //read in the data from the shp file
   read_header(inf,icon_addr[i]);
   if (header.xstart>=0) //skip the problem icons
      read_shp(unit_bmp[i],inf,icon_addr[i]);
  }
  fclose(inf);
  return 0;
}

int load_names()
{
   FILE *inf;
   int total_names,i;

   inf=fopen(names_file,"rb");
   if (!inf)
   {
      printf("Could not open names file\n");
      return 70;
   }
   fread(&total_names,2,1,inf);
   if (total_names>MAX_NAMES) total_names=MAX_NAMES;
   for (i=0; i<total_names; ++i)
     fread(&(gln[i][0]),20,1,inf);
   fclose(inf);
   return 0;
}

int read_map(int n)
{
   char fname[32];
   FILE *inf;
   int x,y;

   sprintf(fname,"Map%02d.set",n);
   inf=fopen(fname,"rb");
   if (!inf) return 20;

   //get the map size
   fseek(inf,MAP_X_ADDR,SEEK_SET);
   fread(&mapx,2,1,inf);
   fseek(inf,MAP_Y_ADDR,SEEK_SET);
   fread(&mapy,2,1,inf);
   ++mapx; ++mapy; //PG sets this to one less than size i.e. last index
   if (mapx>MAX_MAP_X || mapy>MAX_MAP_Y) exit(121);

   //get the image numbers
   fseek(inf,123+5*mapx*mapy,SEEK_SET);
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
       fread(&(map[x][y].tile),2,1,inf);

   //get the country info
   fseek(inf,123+3*mapx*mapy,SEEK_SET);
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
       fread(&(map[x][y].own),1,1,inf);

   //get the gln numbers
   fseek(inf,123+0*mapx*mapy,SEEK_SET);
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
       fread(&(map[x][y].gln),2,1,inf);

   //get the side info
   fseek(inf,123+4*mapx*mapy,SEEK_SET);
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
       fread(&(map[x][y].side),1,1,inf);

   //get the road connectivity
   fseek(inf,123+2*mapx*mapy,SEEK_SET);
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
       fread(&(map[x][y].rc),1,1,inf);
   fclose(inf);

   //make sure all unit indexes are set to -1 (no unit)
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
     {
      map[x][y].guidx=-1;
      map[x][y].auidx=-1;
     }

   //define the values for the max slider position
   hslide_max=mapx-1-TILES_WIDE;
   dm[dmHSlideIdx].d1=hslide_max;

   vslide_max=mapy-TILES_HIGH;
   dm[dmVSlideIdx].d1=vslide_max;
   dm[dmVSlideIdx].d2=vslide_max;  //control is upside down! high at top!

   // read the utrs from the stm file
   sprintf(fname,"Map%02d.stm",n);
   inf=fopen(fname,"rb");
   if (!inf)
   {
      printf("Couldn't open stm file\n");
      return 25;
   }
   for (y=0; y<mapy; ++y)
     for (x=0; x<mapx; ++x)
       fread(&(map[x][y].utr),2,1,inf);
   fclose(inf);


   return 0;
}

void draw_hexes(int clr)
{
  int x,y,xs,ys;

  for (y=y0-1; y<y0+TILES_HIGH+1; ++y)
   for (x=x0-1; x<x0+TILES_WIDE+1; ++x)
   {
    if (x>=0 && x<mapx && y>=0 && y<mapy)
    {
     xs=(x-x0)*TILE_WIDTH; ys=(y-y0)*TILE_HEIGHT;
     if ((x)%2) ys+=25;
     //draw upper lines of hex
     line(map_bmp,xs+0,ys+24,xs+15,ys+0,clr);
     line(map_bmp,xs+45,ys+0,xs+59,ys+24,clr);
     line(map_bmp,xs+15,ys,xs+45,ys,clr);
    }
   }
}

void draw_map()
{
  int x,y,xs,ys,idx;
  int bmp_num;

  //blank off the edges
    //top row
    rectfill(map_bmp,0,0,map_bmp->w,25,MAP_COLOR);
    //bottom row
    rectfill(map_bmp,0,map_bmp->h-25,map_bmp->w,map_bmp->h,MAP_COLOR);
    //left column
    rectfill(map_bmp,0,0,map_bmp->w+10,map_bmp->h,MAP_COLOR);
    //right column
    rectfill(map_bmp,map_bmp->w-10,map_bmp->w,map_bmp->w,map_bmp->h,MAP_COLOR);
  //draw the tiles
  for (y=y0-1; y<y0+TILES_HIGH+1; ++y)
    for (x=x0-1; x<x0+TILES_WIDE+1; ++x)
    {
      if (x>=0 && x<mapx && y>=0 && y<mapy)
      {
        // show the tile
        xs=(x-x0)*45; ys=(y-y0)*50;
        if ((x)%2) ys+=25;
        masked_blit(til_bmp[map[x][y].tile],map_bmp,0,0,xs,ys,60,50);

        // show the unit if any
        if (map[x][y].guidx>=0 && show_air==0)
        {
          idx=map[x][y].guidx;
          bmp_num=equip[all_units[idx].unum][BMP]+
                 256*equip[all_units[idx].unum][BMP+1];
          masked_blit(unit_bmp[bmp_num],map_bmp,0,0,xs,ys,60,50);
        }
        if (map[x][y].auidx>=0 && show_air==1)
        {
          idx=map[x][y].auidx;
          bmp_num=equip[all_units[idx].unum][BMP]+
                256*equip[all_units[idx].unum][BMP+1];
          masked_blit(unit_bmp[bmp_num],map_bmp,0,0,xs,ys,60,50);
        }
        //put on the flag...if it is a victory we need to change
        if (map[x][y].own && map[x][y].vic)
         masked_blit(flag_bmp[map[x][y].own+24-1],map_bmp,0,0,xs,ys,60,50);
        if (map[x][y].own && map[x][y].vic==0)
         masked_blit(flag_bmp[map[x][y].own-1],map_bmp,0,0,xs,ys,60,50);
      } //end of draw til info
    }
    draw_hexes(3);
    if (edit_op==vic || edit_op==deploy || edit_op==neutral)
    {
       for (y=y0-1; y<y0+TILES_HIGH+1; ++y)
        for (x=x0-1; x<x0+TILES_WIDE+1; ++x)
         if (x>=0 && x<mapx && y>=0 && y<mapy)
         {
            // show the special hex
            xs=(x-x0)*45; ys=(y-y0)*50;
            if ((x)%2) ys+=25;
            if (map[x][y].vic&&edit_op==vic)
            {
              masked_blit(vic_hex_bmp,map_bmp,0,0,xs,ys,60,50);
            }
            if (map[x][y].deploy&&edit_op==deploy)
            {
              masked_blit(vic_hex_bmp,map_bmp,0,0,xs,ys,60,50);
            }
            if (map[x][y].side==3 && edit_op==neutral)
            {
              masked_blit(vic_hex_bmp,map_bmp,0,0,xs,ys,60,50);
            }
          }
     }
}

int count_deploy_hexes()
{
  int x,y,count=0;

  for (y=0; y<mapy; ++y)
    for (x=0; x<mapx; ++x)
      if (map[x][y].deploy) ++count;

  return count;

}


int count_vic_hexes()
{
  int x,y,count=0;

  for (y=0; y<mapy; ++y)
    for (x=0; x<mapx; ++x)
      if (map[x][y].vic) ++count;

  return count;

}

int main(int argc, char *argv[])
{
  int error;
  BITMAP *mousie;


  error=load_tiles();
  if(error) return error;

  error=load_uicons();
  if (error) return error;

  error=load_equip();
  if (error) return error;

  error=load_flags();
  if (error) return error;

  error=load_names();
  if (error) return error;


  if (argc>1)
  {
    scn_number=atoi(argv[1]);
    error=read_map(scn_number);
    if (error)
    {
       printf("\n Could not open map file.\n");
       return error;
    }

  //read_map(scn_number);

  error=load_scn();
  if (error) return error;


  }
  else scn_number=0;


  /* you should always do this at the start of Allegro programs */
   allegro_init();


   /* set up the keyboard handler */
   install_keyboard(); //not now to keep RHIDE working


   /* set graphics mode */
   if (set_gfx_mode(GFX_AUTODETECT, 640, 480, 640, 480)<0) return 1;
   set_color_depth(8);
   set_color_conversion(COLORCONV_REDUCE_TO_256);
   /* set the color pallete */
   set_pallete(pgpal);

   install_timer();
   /* try mouse */
   //--------These are required ...
   error=install_mouse();
   if (error<0) return 8;
   show_mouse(screen);
   //...--------to show the default mouse

   mousie=create_bitmap(11,11);
   rectfill(mousie,0,0,11,11,0);
   line(mousie,0,5,11,5,15);
   line(mousie,5,0,5,11,15);
   circle(mousie,5,5,5,22);
   set_mouse_sprite(mousie);
   set_mouse_sprite_focus(5,5);
   set_mouse_speed(1,1);




   /*----------------Set up Bitmaps -------------------------- */
   map_bmp=create_bitmap(MAP_W,MAP_H);
   rectfill(map_bmp,0,0,MAP_W,MAP_H,MAP_COLOR);
   draw_map();
   dm[dmMapBmpIdx].dp=map_bmp;
 //  blit(map_bmp,screen,0,0,0,LINE_2_Y,MAP_W,MAP_H);

   left_arrow_bmp=create_bitmap(HSLIDE_H,HSLIDE_H);
   rectfill(left_arrow_bmp,0,0,HSLIDE_H,HSLIDE_H,SLIDE_BG_COLOR);
   triangle(left_arrow_bmp,0,HSLIDE_H/2, HSLIDE_H,0, HSLIDE_H,HSLIDE_H,
              SLIDE_FG_COLOR);
   dm[dmLeftArrowIdx].dp=left_arrow_bmp;

   right_arrow_bmp=create_bitmap(HSLIDE_H,HSLIDE_H);
   rectfill(right_arrow_bmp,0,0,HSLIDE_H,HSLIDE_H,SLIDE_BG_COLOR);
   triangle(right_arrow_bmp,HSLIDE_H,HSLIDE_H/2, 0,0, 0,HSLIDE_H,
              SLIDE_FG_COLOR);
   dm[dmRightArrowIdx].dp=right_arrow_bmp;

   up_arrow_bmp=create_bitmap(VSLIDE_W,VSLIDE_W);
   rectfill(up_arrow_bmp,0,0,VSLIDE_W,VSLIDE_W,SLIDE_BG_COLOR);
   triangle(up_arrow_bmp,VSLIDE_W/2,0, 0,VSLIDE_W, VSLIDE_W,VSLIDE_W,
              SLIDE_FG_COLOR);
   dm[dmUpArrowIdx].dp=up_arrow_bmp;

   down_arrow_bmp=create_bitmap(VSLIDE_W,VSLIDE_W);
   rectfill(down_arrow_bmp,0,0,VSLIDE_W,VSLIDE_W,SLIDE_BG_COLOR);
   triangle(down_arrow_bmp,0,0, VSLIDE_W/2,VSLIDE_W, VSLIDE_W,0,
              SLIDE_FG_COLOR);
   dm[dmDownArrowIdx].dp=down_arrow_bmp;

   //make the victory hex
   vic_hex_bmp=create_bitmap(60,50);
   rectfill(vic_hex_bmp,0,0,60,50,0);
   //top part
   line(vic_hex_bmp,0,24,15,0,VIC_HEX_COLOR);
   line(vic_hex_bmp,45,0,59,24,VIC_HEX_COLOR);
   line(vic_hex_bmp,15,0,45,0,VIC_HEX_COLOR);
   line(vic_hex_bmp,1,24,16,0,VIC_HEX_COLOR);
   line(vic_hex_bmp,45,1,59,25,VIC_HEX_COLOR);
   line(vic_hex_bmp,15,1,44,1,VIC_HEX_COLOR);
   // bottom part
   line(vic_hex_bmp,0,24,15,49,VIC_HEX_COLOR);
   line(vic_hex_bmp,45,49,60,24,VIC_HEX_COLOR);
   line(vic_hex_bmp,15,49,45,49,VIC_HEX_COLOR);
   line(vic_hex_bmp,1,24,16,49,VIC_HEX_COLOR);
   line(vic_hex_bmp,44,49,59,24,VIC_HEX_COLOR);
   line(vic_hex_bmp,15,48,45,48,VIC_HEX_COLOR);
   initialize_dm();

   do_dialog(dm,-1);

   return 0;
}
