/* SCEN.C is the scenario dialog page */

#include "fpge.h"
#include "allegro.h"

#define SD_FG_COLOR 74
#define SD_BG_COLOR 69 //16
#define EDIT_FG_COLOR 14
#define EDIT_BG_COLOR 69 //16

#define CWIDTH  68
#define RHEIGHT 15

#define ROW1 5
#define ROW2 ROW1+RHEIGHT
#define ROW3 ROW1+2*RHEIGHT
#define ROW4 ROW1+3*RHEIGHT
#define ROW5 ROW1+4*RHEIGHT

#define COL1 5
#define COL2 COL1+CWIDTH
#define COL3 COL1+2*CWIDTH
#define COL5 COL1+4*CWIDTH
#define COL6 COL1+5*CWIDTH
#define COL7 COL1+6*CWIDTH
#define COL8 COL1+7*CWIDTH
#define COL9 COL1+8*CWIDTH

#define sdScnNumEditIdx 3
#define sdCtyNumEdit1Idx 7
#define sdCtyListIdx 17
#define sdOrtRtRBIdx 19
#define sdOrtLfRBIdx 20
#define sdFrtYRBIdx  22
#define sdFrtNRBIdx  23

#define sdAxisOffRBIdx 25
#define sdAxisDefRBIdx 26
#define sdAlldOffRBIdx 28
#define sdAlldDefRBIdx 29

#define sdNALocRBIdx 31
#define sdSELocRBIdx 32
#define sdNELocRBIdx 33
#define sdEELocRBIdx 34

#define sdCurCoreIdx 41
#define sdCurAuxIdx  42
#define sdCurAlldIdx 43

#define sdMaxCoreIdx 44
#define sdMaxAuxIdx  45
#define sdMaxAlldIdx 46

#define sdMonthIdx  48
#define sdDayIdx 49
#define sdYearIdx 50

#define sdTurnsIdx 57
#define sdTurnsPerDayIdx 58
#define sdDaysPerTurnIdx 59

#define sdAxisPrestigeAmtIdx 65
#define sdAlldPrestigeAmtIdx 66
#define sdAxisPrestigeTurnsIdx 67
#define sdAlldPrestigeTurnsIdx 68

#define sdAxisPrestigeIdx 73
#define sdAlliedPrestigeIdx 74

#define sdAxisAirTransNumIdx 82
#define sdAlldAirTransNumIdx 83
#define sdAxisAirTransTypeIdx 84
#define sdAlldAirTransTypeIdx 85

#define sdAxisSeaTransNumIdx 86
#define sdAlldSeaTransNumIdx 87
#define sdAxisSeaTransTypeIdx 88
#define sdAlldSeaTransTypeIdx 89
#define sdVicTxtBoxIdx 90

int d_clr_proc(int,DIALOG *,int);
int d_ctyedit_proc(int,DIALOG *,int);
int d_cancelbtn_proc(int,DIALOG*,int);

// use this flag so that the cancel button doesn't save
int save_data; //set this true on entry false by cancel button

// strings to hold data for the scenario dialog
char ScnStr[8];
char CtyStr[10][8];

char CurCoreStr[8];
char CurAuxStr[8];
char CurAlldStr[8];
char MaxCoreStr[8];
char MaxAuxStr[8];
char MaxAlldStr[8];

char MonthStr[8];
char DayStr[8];
char YearStr[8];

char TurnsStr[8];
char TpdStr[8];
char DptStr[8];

char AxisPrestigeAmtStr[8];
char AlldPrestigeAmtStr[8];
char AxisPrestigeTurnsStr[8];
char AlldPrestigeTurnsStr[8];

char AxisPrestigeStr[8];
char AlliedPrestigeStr[8];

char AxisAirTransNumStr[8];
char AlldAirTransNumStr[8];
char AxisAirTransTypeStr[8];
char AlldAirTransTypeStr[8];

char AxisSeaTransNumStr[8];
char AlldSeaTransNumStr[8];
char AxisSeaTransTypeStr[8];
char AlldSeaTransTypeStr[8];

char VictoryStr[256];

DIALOG sd[]={

  // 0 clear
  {
     d_clr_proc,
     0,0,640,480,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     0,0,0
  },
  // 1 done
  {
     d_button_proc,
     560,ROW1,56,15,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     D_EXIT,
     0,0,
     "Done",0,0
  },
  // 2 text
  {
     d_text_proc,
     COL1,ROW1,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Scen #",0,0
  },
  // 3 ScenNumEdit
  {
     d_edit_proc,
     COL2,ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
  // 4 text
  {
     d_text_proc,
     (COL1+CWIDTH/3),ROW3,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Countries",0,0
  },
  // 5 text
  {
     d_text_proc,
     COL1,ROW3+RHEIGHT,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Axis",0,0
  },
  // 6 text
  {
     d_text_proc,
     COL2,ROW3+RHEIGHT,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Allied",0,0
  },
  // 7 axis country 1
  {
     d_ctyedit_proc,
     COL1,4*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
  // 8 allied country 1
  {
     d_ctyedit_proc,
     COL2,4*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },

   // 9 axis country 2
  {
     d_ctyedit_proc,
     COL1,5*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
  // 10 allied country 2
  {
     d_ctyedit_proc,
     COL2,5*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },

   // 11 axis country 3
  {
     d_ctyedit_proc,
     COL1,6*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
  // 12 allied country 3
  {
     d_ctyedit_proc,
     COL2,6*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
   // 13 axis country 4
  {
     d_ctyedit_proc,
     COL1,7*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
  // 14 allied country 4
  {
     d_ctyedit_proc,
     COL2,7*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
   // 15 axis country 5
  {
     d_ctyedit_proc,
     COL1,8*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
  // 16 allied country 5
  {
     d_ctyedit_proc,
     COL2,8*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
  },
  // 17 country list box
  {
     d_list_proc,
     COL3,ROW3,2*CWIDTH-5,15*RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     0,0,
     add_countries,0,0
  },
  // 18 icon orientation
  {
     d_text_proc,
     COL1,10*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Axis Icons Point",0,0
  },
  // 19 OrtRtRB
  {
     d_radio_proc,
     COL1,11*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     100,0,
     "-->",0,0
  },
  // 20 OrtLfRB
  {
     d_radio_proc,
     COL2,11*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     100,0,
     "<--",0,0
  },
  // 21
 {
     d_text_proc,
     COL1,13*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Weather Front",0,0
 },
 // 22 sdFrtYRB
{
     d_radio_proc,
     COL1,14*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     200,0,
     "Yes",0,0
},
// 23 sdFrtNRB
{
     d_radio_proc,
     COL2,14*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     200,0,
     "No",0,0
},
// 24
 {
     d_text_proc,
     COL1,23*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Axis Stance",0,0
 },
// 25 sdAxisOff
{
     d_radio_proc,
     COL1,24*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     300,0,
     "Offense",0,0
},
// 26 sdAxisDef
{
     d_radio_proc,
     COL2+20,24*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     300,0,
     "Defense",0,0
},
// 27
 {
     d_text_proc,
     COL1,25*RHEIGHT+ROW1+5,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Allied Stance",0,0
 },
// 28 sdAlldOff
{
     d_radio_proc,
     COL1,26*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     310,0,
     "Offense",0,0
},
// 29 sdAlldDef
{
     d_radio_proc,
     COL2+20,26*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     310,0,
     "Defense",0,0
},
// 30 Scenario Locale
 {
     d_text_proc,
     COL1,16*RHEIGHT+ROW1+5,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Scenario Local",0,0
 },
// 31 North Africa
{
     d_radio_proc,
     COL1,17*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     400,0,
     "North Africa",0,0
},
// 32 S. Europe
{
     d_radio_proc,
     COL1,18*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     400,0,
     "South Europe",0,0
},
// 33 N. Europe
{
     d_radio_proc,
     COL1,19*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     400,0,
     "North Europe",0,0
},
// 34 E. Europe
{
     d_radio_proc,
     COL1,20*RHEIGHT+ROW1,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     400,0,
     "East Europe",0,0
},
// 35
{
     d_text_proc,
     COL6,ROW2,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Number of Units",0,0
 },
//36
{
     d_text_proc,
     COL6-10,ROW3,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Core",0,0
 },
//37
{
     d_text_proc,
     COL7-10,ROW3,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Aux",0,0
 },
 //38
 {
     d_text_proc,
     COL8-10,ROW3,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Allied",0,0
 },
 //39
{
     d_text_proc,
     COL5,ROW4,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Maximum",0,0
 },
//40
{
     d_text_proc,
     COL5,ROW5,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Current",0,0
 },
//41 current core sdCurCore
{
     d_text_proc,
     COL6,ROW5,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     0,0,0
 },
//42 current core sdCurAux
{
     d_text_proc,
     COL7,ROW5,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     0,0,0
 },
//43 current core sdCurAlld
{
     d_text_proc,
     COL8,ROW5,CWIDTH,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     0,0,0
 },
// 44 sdMaxCore
{
     d_edit_proc,
     COL6,ROW4,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
 },
// 45 sdMaxAux
{
     d_edit_proc,
     COL7,ROW4,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
 },
// 46 sdMaxAlld
{
     d_edit_proc,
     COL8,ROW4,CWIDTH,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     7,0,
     0,0,0
 },
//these next few are the date dd/mm/yr
// 47
{
     d_text_proc,
     COL3,ROW1,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Date",0,0
 },
// 48 the month field
{
     d_edit_proc,
     COL3+40,ROW1,24,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
// 49 the day field
{
     d_edit_proc,
     COL3+72,ROW1,24,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
// 50 the day field
{
     d_edit_proc,
     COL3+104,ROW1,24,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
// 51 date format string
{
     d_text_proc,
     COL3+40,ROW2,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "(mm/dd/yr)",0,0
 },
// 52 a slash date separator
{
     d_text_proc,
     COL3+60,ROW1,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "/",0,0
 },
//53 another slash separator
{
     d_text_proc,
     COL3+92,ROW1,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "/",0,0
 },
//54 turns label
{
     d_text_proc,
     COL6,ROW5+2*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Turns",0,0
 },
//55 T/day label
{
     d_text_proc,
     COL6,ROW5+3*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "T/Day",0,0
 },
//56 Day/T label
{
     d_text_proc,
     COL6,ROW5+4*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Day/T",0,0
 },
//57 the turns edit
{
     d_edit_proc,
     COL7,ROW5+2*RHEIGHT,36,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
//58 the turns/day edit
{
     d_edit_proc,
     COL7,ROW5+3*RHEIGHT,36,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
//59 the day/t edit
{
     d_edit_proc,
     COL7,ROW5+4*RHEIGHT,36,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
// 60 Prestige Label
{
     d_text_proc,
     COL6-CWIDTH/2,ROW5+6*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "AI Prestige Settings",0,0
 },
// 61
{
     d_text_proc,
     COL6,ROW5+7*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Axis",0,0
 },
// 62
{
     d_text_proc,
     COL7,ROW5+7*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Allied",0,0
 },
// 63
{
     d_text_proc,
     COL5,ROW5+8*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Amount",0,0
 },
// 64
{
     d_text_proc,
     COL5,ROW5+9*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Turns",0,0
 },
//65 Axis AI amt
{
     d_edit_proc,
     COL6,ROW5+8*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     5,0,
     0,0,0
 },
//66 Alld AI amt
{
     d_edit_proc,
     COL7,ROW5+8*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     5,0,
     0,0,0
 },
//67 Axis AI turns
{
     d_edit_proc,
     COL6,ROW5+9*RHEIGHT,36,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
//68 Alld AI turns
{
     d_edit_proc,
     COL7,ROW5+9*RHEIGHT,36,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
// 69 Cancel
  {
     d_cancelbtn_proc,
     560,ROW3,56,15,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     D_EXIT,
     0,0,
     "Cancel",0,0
  },
// 70 Prestige label
{
     d_text_proc,
     COL5+CWIDTH/2,ROW5+11*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Starting Prestige",0,0
 },
//71 Axis Prestige label
{
     d_text_proc,
     COL5+CWIDTH/2,ROW5+12*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Axis",0,0
 },
//72 Allied Prestige label
{
     d_text_proc,
     COL5+CWIDTH/2,ROW5+13*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Allied",0,0
 },
//73 sdAxisPrestige
{
     d_edit_proc,
     COL6+CWIDTH/2,ROW5+12*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     5,0,
     0,0,0
 },


//74 sdAlliedPrestige
{
     d_edit_proc,
     COL6+CWIDTH/2,ROW5+13*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     5,0,
     0,0,0
 },
//75 aux transport label
{
     d_text_proc,
     COL5+CWIDTH/2,ROW5+15*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Auxillary Transport",0,0
 },
// 76 Axis transport Label
{
     d_text_proc,
     COL6,ROW5+16*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Axis",0,0
},
// 77 Allied transport
{
     d_text_proc,
     COL7,ROW5+16*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Allied",0,0
},
// 78 Air Number label
{
     d_text_proc,
     COL5,ROW5+17*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Air #",0,0
},
// 79 Air type
{
     d_text_proc,
     COL5,ROW5+18*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "A/Type",0,0
},
// 80 Sea Number label
{
     d_text_proc,
     COL5,ROW5+19*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "Sea #",0,0
},
// 81 Sea type
{
     d_text_proc,
     COL5,ROW5+20*RHEIGHT,36,RHEIGHT,
     SD_FG_COLOR,SD_BG_COLOR,
     0,
     0,
     0,0,
     "S/Type",0,0
},
//82 AxisAirTransNum
{
     d_edit_proc,
     COL6,ROW5+17*RHEIGHT,36,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     2,0,
     0,0,0
 },
//83 AlliedAirTransNum
{
     d_edit_proc,
     COL7,ROW5+17*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     4,0,
     0,0,0
 },
//84 AxisAirTransType
{
     d_edit_proc,
     COL6,ROW5+18*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     4,0,
     0,0,0
 },
//85 AlliedAirTransType
{
     d_edit_proc,
     COL7,ROW5+18*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     4,0,
     0,0,0
 },
//86 AxisSeaTransNum
{
     d_edit_proc,
     COL6,ROW5+19*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     4,0,
     0,0,0
 },
 //87 AlldSeanTransNum
 {
     d_edit_proc,
     COL7,ROW5+19*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     4,0,
     0,0,0
 },
//88 AxisSeaTranstype
{
     d_edit_proc,
     COL6,ROW5+20*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     4,0,
     0,0,0
 },
 //89 AlldSeaTranstype
 {
     d_edit_proc,
     COL7,ROW5+20*RHEIGHT,48,RHEIGHT,
     EDIT_FG_COLOR,EDIT_BG_COLOR,
     0,
     0,
     4,0,
     0,0,0
 },
//90 Victory..
{
   d_textbox_proc,
   520,100,110,192,
   SD_FG_COLOR,SD_BG_COLOR,
   0,
   0,
   0,0,
   0,0,0
},

// last
  {NULL}
};

//a click on the country edit shoul denter the current country from the lb
int d_ctyedit_proc(int msg,DIALOG *d,int c)
{
   int i;

   //when a country edit is clicked on it gets the current country
   //from the country list box
   if (msg==MSG_CLICK)
   {
     for (i=0; i<10; ++i)
     {
        if (&(sd[sdCtyNumEdit1Idx+i])==d)
           sprintf(CtyStr[i],"%d",sd[sdCtyListIdx].d1);
     }

   }
   return d_edit_proc(msg,d,c);
}
// the cancel button sets the save_data flag to 0 so data is
// not saved on exit
int d_cancelbtn_proc(int msg,DIALOG *d,int c)
{
    if (msg==MSG_CLICK)
      save_data=0;
    return d_button_proc(msg,d,c);
}

//use this to initialize variables  and save them on exit
int d_clr_proc(int msg,DIALOG *d,int c)
{
  int i;
  char str[32];

  //initialize everything that needs it
  if (msg==MSG_START)
  {
    save_data=1; //default is to save

    sprintf(ScnStr,"%d",scn_number);
    sd[sdScnNumEditIdx].dp=ScnStr;
    //coutries
    for (i=0; i<10; ++i)
    {
       sprintf(&(CtyStr[i]),"%d",scn_buffer[i]&255);
       sd[sdCtyNumEdit1Idx+i].dp=&(CtyStr[i]);
    }
    //orientation
    if (scn_buffer[ORIENTATION]==1)
      sd[sdOrtRtRBIdx].flags=D_SELECTED;
    else
      sd[sdOrtLfRBIdx].flags=D_SELECTED;

    //storm front
    if (scn_buffer[STORM_FRONT]==0)
      sd[sdFrtYRBIdx].flags=D_SELECTED;
    else
      sd[sdFrtNRBIdx].flags=D_SELECTED;

   // offense defense
   if (scn_buffer[AXIS_STANCE]==0)
      sd[sdAxisDefRBIdx].flags=D_SELECTED;
   else
      sd[sdAxisOffRBIdx].flags=D_SELECTED;
   if (scn_buffer[ALLIED_STANCE]==0)
      sd[sdAlldDefRBIdx].flags=D_SELECTED;
    else
      sd[sdAlldOffRBIdx].flags=D_SELECTED;

   //location
   sd[sdNALocRBIdx+scn_buffer[SCEN_LOCALE]].flags=D_SELECTED;

   sprintf(CurCoreStr,"%d",scn_buffer[CORE_UNITS]&255);
   sprintf(CurAuxStr,"%d",scn_buffer[AUX_UNITS]&255);
   sprintf(CurAlldStr,"%d",scn_buffer[ALLIED_UNITS]&255);
   sd[sdCurCoreIdx].dp=CurCoreStr;
   sd[sdCurAuxIdx].dp=CurAuxStr;
   sd[sdCurAlldIdx].dp=CurAlldStr;
 
   //setup the Max for units
   sprintf(MaxCoreStr,"%d",scn_buffer[CORE_UNITS_LIMIT]&255);
   sprintf(MaxAuxStr,"%d",scn_buffer[AUX_UNITS_LIMIT]&255);
   sprintf(MaxAlldStr,"%d",scn_buffer[ALLIED_UNITS_LIMIT]&255);
   sd[sdMaxCoreIdx].dp=MaxCoreStr;
   sd[sdMaxAuxIdx].dp=MaxAuxStr;
   sd[sdMaxAlldIdx].dp=MaxAlldStr;
 
   //date
   sd[sdMonthIdx].dp=MonthStr;
   sd[sdDayIdx].dp=DayStr;
   sd[sdYearIdx].dp=YearStr;
   sprintf(MonthStr,"%02d",scn_buffer[MONTH]&255);
   sprintf(DayStr,"%02d",scn_buffer[DAY]&255);
   sprintf(YearStr,"%02d",scn_buffer[YEAR]&255);
 
   //turns
   sd[sdTurnsIdx].dp=TurnsStr;
   sd[sdTurnsPerDayIdx].dp=TpdStr;
   sd[sdDaysPerTurnIdx].dp=DptStr;
   sprintf(TurnsStr,"%d",scn_buffer[TURNS]&255);
   sprintf(TpdStr,"%d",scn_buffer[TURNS_PER_DAY]&255);
   sprintf(DptStr,"%d",scn_buffer[DAYS_PER_TURN]&255);
 
   // AI prestige
   sd[sdAxisPrestigeAmtIdx].dp=AxisPrestigeAmtStr;
   sd[sdAlldPrestigeAmtIdx].dp=AlldPrestigeAmtStr;
   sd[sdAxisPrestigeTurnsIdx].dp=AxisPrestigeTurnsStr;
   sd[sdAlldPrestigeTurnsIdx].dp=AlldPrestigeTurnsStr;
   sprintf(AxisPrestigeAmtStr,"%d",scn_buffer[AI_AXIS_BUCKET]+
                                 256*scn_buffer[AI_AXIS_BUCKET+1]);
   sprintf(AlldPrestigeAmtStr,"%d",scn_buffer[AI_ALLIED_BUCKET]+
                                  256*scn_buffer[AI_ALLIED_BUCKET+1]);
   sprintf(AxisPrestigeTurnsStr,"%d",scn_buffer[AI_AXIS_INTERVAL])&0xFF;
   sprintf(AlldPrestigeTurnsStr,"%d",scn_buffer[AI_ALLIED_INTERVAL])&0xFF;
 
   //starting prestige
   sprintf(AxisPrestigeStr,"%d",
            s4_buffer[AXIS_PRESTIGE]+256*s4_buffer[AXIS_PRESTIGE+1]);
   sprintf(AlliedPrestigeStr,"%d",
            s4_buffer[ALLIED_PRESTIGE]+256*s4_buffer[ALLIED_PRESTIGE+1]);
   sd[sdAxisPrestigeIdx].dp=AxisPrestigeStr;
   sd[sdAlliedPrestigeIdx].dp=AlliedPrestigeStr;
 
   //air aux transport
   sprintf(AxisAirTransNumStr,"%d",s4_buffer[AXIS_AIR_NUMBER]);
   sprintf(AlldAirTransNumStr,"%d",s4_buffer[ALLIED_AIR_NUMBER]);
   sprintf(AxisAirTransTypeStr,"%d",s4_buffer[AXIS_AIR_TYPE]+
                          256*s4_buffer[AXIS_AIR_TYPE+1]);
   sprintf(AlldAirTransTypeStr,"%d",s4_buffer[ALLIED_AIR_TYPE]+
                          256*s4_buffer[ALLIED_AIR_TYPE+1]);
   sd[sdAxisAirTransNumIdx].dp=AxisAirTransNumStr;
   sd[sdAxisAirTransTypeIdx].dp=AxisAirTransTypeStr;
   sd[sdAlldAirTransNumIdx].dp=AlldAirTransNumStr;
   sd[sdAlldAirTransTypeIdx].dp=AlldAirTransTypeStr;
 
   //sea aux transport
   sprintf(AxisSeaTransNumStr,"%d",s4_buffer[AXIS_SEA_NUMBER]);
   sprintf(AlldSeaTransNumStr,"%d",s4_buffer[ALLIED_SEA_NUMBER]);
   sprintf(AxisSeaTransTypeStr,"%d",s4_buffer[AXIS_SEA_TYPE]+
                          256*s4_buffer[AXIS_SEA_TYPE+1]);
   sprintf(AlldSeaTransTypeStr,"%d",s4_buffer[ALLIED_SEA_TYPE]+
                          256*s4_buffer[ALLIED_SEA_TYPE+1]);
   sd[sdAxisSeaTransNumIdx].dp=AxisSeaTransNumStr;
   sd[sdAxisSeaTransTypeIdx].dp=AxisSeaTransTypeStr;
   sd[sdAlldSeaTransNumIdx].dp=AlldSeaTransNumStr;
   sd[sdAlldSeaTransTypeIdx].dp=AlldSeaTransTypeStr;

   //the victory hex info box
   sd[sdVicTxtBoxIdx].dp=VictoryStr;
   sprintf(VictoryStr,"Victory Hexes\n  x, y, own\n");
   for (i=0; i<20; ++i)
   {
      sprintf(str," %2d,%2d,  %d\n",victory_hexes[i].x,
                                    victory_hexes[i].y,
                                    victory_hexes[i].own);
     strcat(VictoryStr,str);

   }

  //-------- end initialize
  }
  //make changes where they are need
  if (msg==MSG_END && save_data)
  {
    //scenario number
    scn_number=atoi(ScnStr);
    //countries
    for (i=0; i<10; ++i)
      scn_buffer[i]=atoi(CtyStr[i]);
    //orientation
    if (sd[sdOrtRtRBIdx].flags&D_SELECTED)
    {
      scn_buffer[ORIENTATION]=1;
      scn_buffer[ORIENTATION+1]=0;
    }
    else
    {
      scn_buffer[ORIENTATION]=255;
      scn_buffer[ORIENTATION+1]=255;
    }
    //storm front
    if (sd[sdFrtYRBIdx].flags&D_SELECTED)
      scn_buffer[STORM_FRONT]=0;
    else
      scn_buffer[STORM_FRONT]=1;

    // axis allied stance
    if (sd[sdAxisDefRBIdx].flags&D_SELECTED)
      scn_buffer[AXIS_STANCE]=0;
    else
      scn_buffer[AXIS_STANCE]=1;
    if (sd[sdAlldDefRBIdx].flags&D_SELECTED)
       scn_buffer[ALLIED_STANCE]=0;
    else
      scn_buffer[ALLIED_STANCE]=1;

    //locale
    for (i=0; i<4; ++i)
     if (sd[sdNALocRBIdx+i].flags&D_SELECTED) scn_buffer[SCEN_LOCALE]=i;

    //max strength
    scn_buffer[CORE_UNITS_LIMIT]=atoi(MaxCoreStr)&255;
    scn_buffer[AUX_UNITS_LIMIT]=atoi(MaxAuxStr)&255;
    scn_buffer[ALLIED_UNITS_LIMIT]=atoi(MaxAlldStr)&255;

    //date
    scn_buffer[MONTH]=atoi(MonthStr)&255;
    scn_buffer[DAY]=atoi(DayStr)&255;
    scn_buffer[YEAR]=atoi(YearStr)&255;

    //turns
    scn_buffer[TURNS]=atoi(TurnsStr);
    scn_buffer[TURNS_PER_DAY]=atoi(TpdStr);
    scn_buffer[DAYS_PER_TURN]=atoi(DptStr);

    //AI prestige
    scn_buffer[AI_AXIS_BUCKET]=atoi(AxisPrestigeAmtStr)&255;
    scn_buffer[AI_AXIS_BUCKET+1]=atoi(AxisPrestigeAmtStr)/256;
    scn_buffer[AI_ALLIED_BUCKET]=atoi(AlldPrestigeAmtStr)&255;
    scn_buffer[AI_ALLIED_BUCKET+1]=atoi(AlldPrestigeAmtStr)/256;
    scn_buffer[AI_AXIS_INTERVAL]=atoi(AxisPrestigeTurnsStr);
    scn_buffer[AI_ALLIED_INTERVAL]=atoi(AlldPrestigeTurnsStr);

    //starting prestige
    s4_buffer[AXIS_PRESTIGE]=atoi(AxisPrestigeStr)&255;
    s4_buffer[AXIS_PRESTIGE+1]=atoi(AxisPrestigeStr)/256;
    s4_buffer[ALLIED_PRESTIGE]=atoi(AlliedPrestigeStr)&255;
    s4_buffer[ALLIED_PRESTIGE+1]=atoi(AlliedPrestigeStr)/256;

    // aux air transports
    s4_buffer[AXIS_AIR_NUMBER]=atoi(AxisAirTransNumStr);
    s4_buffer[ALLIED_AIR_NUMBER]=atoi(AlldAirTransNumStr);
    s4_buffer[AXIS_AIR_TYPE]=atoi(AxisAirTransTypeStr)&255;
    s4_buffer[AXIS_AIR_TYPE+1]=atoi(AxisAirTransTypeStr)/256;
    s4_buffer[ALLIED_AIR_TYPE]=atoi(AlldAirTransTypeStr)&255;
    s4_buffer[ALLIED_AIR_TYPE+1]=atoi(AlldAirTransTypeStr)/256;

    // aux sea transports
    s4_buffer[AXIS_SEA_NUMBER]=atoi(AxisSeaTransNumStr);
    s4_buffer[ALLIED_SEA_NUMBER]=atoi(AlldSeaTransNumStr);
    s4_buffer[AXIS_SEA_TYPE]=atoi(AxisSeaTransTypeStr)&255;
    s4_buffer[AXIS_SEA_TYPE+1]=atoi(AxisSeaTransTypeStr)/256;
    s4_buffer[ALLIED_SEA_TYPE]=atoi(AlldSeaTransTypeStr)&255;
    s4_buffer[ALLIED_SEA_TYPE+1]=atoi(AlldSeaTransTypeStr)/256;
  }

  return d_clear_proc(msg,d,c);
}

