/* Unit.c the unit selection dialog called when the Unit */
/* button of FPGE is presses                             */

#include "allegro.h"
#include "fpge.h"

#define UNIT_SCREEN_COLOR 33
#define UNIT_FG_COLOR 15
#define UNIT_BG_COLOR 38
#define EDIT_BG_COLOR 14
#define EDIT_FG_COLOR 4

#define UNIT_TYPE_RB_X 5
#define UNIT_TYPE_RB_Y 10
#define UNIT_TYPE_RB_SPACE 20

#define SBOX_X 420
#define SBOX_Y LINE_1_Y
#define SBOX_H 145
#define SBOX_W 140


#define AIR_CARRIER_TYPE 16
#define SEA_CARRIER_TYPE 17
#define TRUCK_TYPE 15


/* variables for unit.c */
char *unames[MAX_UNITS/2];  //names for list box
short unumbers[MAX_UNITS/2]; //unit numbers for items in listbox

/* declaration of our functions */
int d_setbtn_proc(int,DIALOG *,int);
int d_ulist_proc(int,DIALOG *,int);
int d_uradio_proc(int,DIALOG *,int);
int d_sbox_proc(int,DIALOG *,int);
int d_dradio_proc(int,DIALOG *,int);
char *add_units(int idx,int *list_size);
char *add_countries(int idx,int *list_size);
int d_unumedit_proc(int,DIALOG *,int);
int d_tnumedit_proc(int,DIALOG *,int);
int d_cnumedit_proc(int,DIALOG *,int);
int d_clist_proc(int,DIALOG *,int);
int d_atransedit_proc(int,DIALOG *,int);

/* here we define the unit dialog components */
DIALOG ud[]=
{
//item 0 the clear routine
   { d_clear_proc,
     0,0,0,0,
     0,UNIT_SCREEN_COLOR,
     0,
     0,
     0,0,
     0,0,0},
//item 1 the done button
   { d_button_proc,
     MAIN_BUTTON_X,LINE_1_Y,BUTTON_W,BUTTON_H,
     UNIT_FG_COLOR,UNIT_BG_COLOR,
     0,D_EXIT,
     0,0,
     "DONE",0,0},
//item 2 the set button
  { d_setbtn_proc,
    MAIN_BUTTON_X,LINE_1_Y+20,BUTTON_W,BUTTON_H,
    UNIT_FG_COLOR,UNIT_BG_COLOR,
    0,0,
    0,0,
    "Set",0,0},
//item 3 the 1st radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,1*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,D_SELECTED,
    1,0,
    "Infantry",0,0 },
//item 4 the 2nd radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,2*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Tank",0,0 },
//item 5 the 3rd radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,3*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Recon",0,0 },
//item 6 the 4th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,4*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Anti-Tank",0,0 },
//item 7 the 5th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,5*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Artillery",0,0 },
//item 8 the 6th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,6*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Anti-Aircraft",0,0 },
//item 9 the 7th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,7*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Air Defense",0,0 },

//item 10 the 8th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,8*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Fortification",0,0 },

//item 11 the 9th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,9*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Fighter",0,0 },

//item 12 the 10th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,10*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Tactical Bomber",0,0 },


//item 13 the 11th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,11*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Level Bomber",0,0 },


//item 14 the 12th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,12*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Submarine",0,0 },


//item 15 the 13th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,13*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Destroyer",0,0 },

//item 16 the 14th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,14*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Capital Ship",0,0 },


//item 17 the 15th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,15*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Aircraft Carrier",0,0 },


//item 18 the 16th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,16*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Land Transport",0,0 },


//item 19 the 17th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,17*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Air Transport",0,0 },

//item 20 the 18th radio button of group 1
  {
    d_uradio_proc,
    UNIT_TYPE_RB_X,18*UNIT_TYPE_RB_SPACE,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    1,0,
    "Sea Transport",0,0 },

//item 21 the list of appropriate units
  {
    d_ulist_proc,
    UNIT_TYPE_RB_X+200,LINE_1_Y,180,302,
    UNIT_FG_COLOR,UNIT_BG_COLOR,
    0,0,
    0,0,
    add_units,0,0 },
//item 22 the box for selections
{
    d_sbox_proc,
    SBOX_X,SBOX_Y,SBOX_W,SBOX_H,
    UNIT_FG_COLOR,UNIT_BG_COLOR,
    0,0,
    0,0,
    0,0,0 },

//item 23 an edit box  for the unit number
{
    d_unumedit_proc,
    SBOX_X+10,SBOX_Y+28,36,15,
    EDIT_FG_COLOR,EDIT_BG_COLOR,
    //4,15,
    4,0,
    0,0,
    0,0,0 },  //initialize on starting

//item 24 an edit box  for the transport number
{
    d_tnumedit_proc,
    SBOX_X+10,SBOX_Y+64,36,15,
    EDIT_FG_COLOR,EDIT_BG_COLOR,
    //4,15,
    4,0,
    0,0,
    0,0,0 },  //initialize on starting

//item 25 an edit box  for the country number
{
    d_cnumedit_proc,
    SBOX_X+10,SBOX_Y+100,36,15,
    EDIT_FG_COLOR,EDIT_BG_COLOR,
    //4,15,
    4,0,
    0,0,
    0,0,0 },  //initialize on starting
//item 26 the country list box
{
    d_clist_proc,
    SBOX_X,SBOX_Y+160,SBOX_W,220,
    UNIT_FG_COLOR,UNIT_BG_COLOR,
    //4,15,
    3,0,
    0,0,
    add_countries,0,0 },  //initialize on starting
//item 27 the auxtransport edit
{
    d_atransedit_proc,
    SBOX_X+10,SBOX_Y+125,36,15,
    EDIT_FG_COLOR,EDIT_BG_COLOR,
    //4,15,
    3,0,
    0,0,
    0,0,0 },  //initialize on starting
// item 28 a RB to select all units display the default udAllUnitIdx
  {
    d_dradio_proc,
    UNIT_TYPE_RB_X+200,340,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,D_SELECTED,
    100,0,
    "All Units",0,0 },

// item 29 a RB to display date sensitive
  {
    d_dradio_proc,
    UNIT_TYPE_RB_X+295,340,10,10,
    UNIT_FG_COLOR,UNIT_SCREEN_COLOR,
    0,0,
    100,0,
    "By Date",0,0 },

// last item
   { NULL}
} ;

#define udDoneBtnIdx 1
#define udSetBtnIdx 2
#define udListBoxIdx 21
#define udAllUnitIdx 28
int d_setbtn_proc(int msg,DIALOG *d,int c)
{
    if (msg==MSG_CLICK)
    {
       d_button_proc(msg,d,c);
       sprintf(uselected,"%d",unum_selected);
       sprintf(tselected,"%d",tnum_selected);
       sprintf(cselected,"%d",cnum_selected);
       sprintf(aselected,"%d",anum_selected);
       d->flags^=D_SELECTED;
       broadcast_dialog_message(MSG_DRAW,0);
       return D_O_K;
    }
    return d_button_proc(msg,d,c);
}

//display the unit info for the unit selected in the box
//idx is for equip list
#define INFO_X 195
#define INFO_Y 360
#define INFO_SPACE 15
#define INFO_W 220
#define INFO_H 100

void display_unit_info(int idx)
{
  char str[32];

  //clear the info area
  rectfill(screen,INFO_X,INFO_Y,INFO_X+INFO_W,INFO_Y+INFO_H,UNIT_SCREEN_COLOR);
  text_mode(-1);
  sprintf(str,"Unit: #%3d %-16s",idx,&(equip[idx][NAME]) );
  textout(screen,font,str,INFO_X,INFO_Y+0*INFO_SPACE,14);
  sprintf(str,"HA:%2d  SA:%2d  AA:%2d NA:%2d",
    equip[idx][HA],equip[idx][SA],equip[idx][AA],equip[idx][NA]);
  textout(screen,font,str,INFO_X,INFO_Y+1*INFO_SPACE,14);
  sprintf(str,"GD:%2d  CD:%2d  AD:%2d",
    equip[idx][GD],equip[idx][CD],equip[idx][AD]);
  textout(screen,font,str,INFO_X,INFO_Y+2*INFO_SPACE,14);
  sprintf(str,"INI:%2d  RNG:%2d  SPT:%2d",
    equip[idx][INI],equip[idx][RNG],equip[idx][SPT]);
  textout(screen,font,str,INFO_X,INFO_Y+3*INFO_SPACE,14);
  sprintf(str,"FUEL:%2d  AMMO:%2d  COST:%2d",
    equip[idx][FUEL],equip[idx][AMMO],equip[idx][COST]);
  textout(screen,font,str,INFO_X,INFO_Y+4*INFO_SPACE,14);

  sprintf(str,"MOV:%2d(%d) ",
    equip[idx][MOV],equip[idx][MOV_TYPE]);
  if (equip[idx][AAF]==0 && equip[idx][CLASS]==9) //bomber that can open fire
    strcat(str,"Fighter/Bomber");
  textout(screen,font,str,INFO_X,INFO_Y+5*INFO_SPACE,14);
  sprintf(str,"Avail:%02d/%02d",equip[idx][MON],equip[idx][YR]);
  textout(screen,font,str,INFO_X,INFO_Y+6*INFO_SPACE,14);
  text_mode(0);
}

int d_unumedit_proc(int msg,DIALOG *d,int c)
{
   if (msg==MSG_START)   //set the string to the correct address
     d->dp=uselected;

   return d_edit_proc(msg,d,c);
}

int d_atransedit_proc(int msg,DIALOG *d,int c)
{
   if (msg==MSG_START)   //set the string to the correct address
     d->dp=aselected;

   return d_edit_proc(msg,d,c);
}

int d_tnumedit_proc(int msg,DIALOG *d,int c)
{
  if (msg==MSG_START)   //set string to address
     d->dp=tselected;

   return d_edit_proc(msg,d,c);
}

int d_cnumedit_proc(int msg,DIALOG *d,int c)
{
  if (msg==MSG_START)   //set string to address
     d->dp=cselected;

   return d_edit_proc(msg,d,c);
}

int d_ulist_proc(int msg, DIALOG *d, int c)
{

    if (msg==MSG_CLICK)
    {
       d_list_proc(msg,d,c);
       display_unit_info(unumbers[d->d1]);
       if (unit_type_selected==TRUCK_TYPE)
         tnum_selected=unumbers[d->d1];
       else if (unit_type_selected==SEA_CARRIER_TYPE ||
                   unit_type_selected==AIR_CARRIER_TYPE)
         anum_selected=unumbers[d->d1];
       else
         unum_selected=unumbers[d->d1];
       return D_O_K;
    }
    return d_list_proc(msg,d,c);

}

char *add_units(int idx,int *list_size)   //function to add units to listbox
{
   int i,number,first_date,last_date,this_date;
   static int next_index; //this is where to start search next time
   static char nstr[]="None";

   if (idx<0) //wants the size)
   {
      for (i=3; i<21; ++i)
        if (ud[i].flags&D_SELECTED) unit_type_selected=i-3;

      //get the date of the scenario
      this_date=12*scn_buffer[YEAR]+scn_buffer[MONTH]-1;
      //search the equipment data base for entries of this type
      number=0;

      for (i=0; i<total_equip; ++i)
      {
         if ((unit_type_selected==TRUCK_TYPE||
              unit_type_selected==AIR_CARRIER_TYPE||
              unit_type_selected==SEA_CARRIER_TYPE) && i==0)
         {
            unames[0]=nstr;
            unumbers[number]=0;
            ++number;
         }

         if (equip[i][CLASS]==unit_type_selected )
         {
            //is correct type...is it in date
            first_date=12*equip[i][YR]+equip[i][MON]-1;
            last_date=12*equip[i][LAST_YEAR]+12;   //end of obsolete year
            if ((this_date>=first_date&&this_date<=last_date)
                || ud[udAllUnitIdx].flags&D_SELECTED)
            {
              unames[number]=(char*)&(equip[i][NAME]);
              unumbers[number]=i;
              ++number;
            }
         }
      }
      *list_size=number;
      return 0;
   }
   return unames[idx];
}

int d_uradio_proc(int msg,DIALOG *d,int c)
{
   if (msg==MSG_CLICK)
   {
      d_radio_proc(msg,d,c);
      ud[udListBoxIdx].d1=-1;ud[udListBoxIdx].d2=0;
      broadcast_dialog_message(MSG_DRAW,c);
      return D_O_K;
   }
   return d_radio_proc(msg,d,c);
}

int d_dradio_proc(int msg,DIALOG *d,int c)
{
   if (msg==MSG_CLICK)
   {
      d_radio_proc(msg,d,c);
      ud[udListBoxIdx].d1=-1;ud[udListBoxIdx].d2=0;
      broadcast_dialog_message(MSG_DRAW,c);
      return D_O_K;
   }
   return d_radio_proc(msg,d,c);
}

int d_sbox_proc(int msg,DIALOG *d,int c)
{
   int temp;

   if (msg==MSG_DRAW)
   {
      d_box_proc(msg,d,c);
      textout(screen,font,"Selected Unit",SBOX_X+4,SBOX_Y+4,UNIT_FG_COLOR);
      textout(screen,font,&(equip[unum_selected][NAME]),
          SBOX_X+4,SBOX_Y+16,UNIT_FG_COLOR);
      textout(screen,font,"Transport",
          SBOX_X+4,SBOX_Y+40,UNIT_FG_COLOR);

      textout(screen,font,&(equip[tnum_selected][NAME]),
          SBOX_X+4,SBOX_Y+52,UNIT_FG_COLOR);

      textout(screen,font,"Country",
          SBOX_X+4,SBOX_Y+76,UNIT_FG_COLOR);
      temp=atoi(cselected);
      textout(screen,font,country_names[temp],
        SBOX_X+4,SBOX_Y+88,UNIT_FG_COLOR);
      textout(screen,font,"Aux. Transport",
         SBOX_X+4,SBOX_Y+112,UNIT_FG_COLOR);

      return D_O_K;
   }
   return d_box_proc(msg,d,c);
}

int d_clist_proc(int msg, DIALOG *d, int c)
{
   if (msg==MSG_CLICK)
   {
      d_list_proc(msg,d,c);
      cnum_selected=d->d1;

      return D_O_K;
   }
   return d_list_proc(msg,d,c);
}

char *add_countries(int idx,int *list_size)
{
   if (idx<0) *list_size=25;
   else return &(country_names[idx][0]);
}
